package com.tin.tds.util;


/* ------------------------------------------------------------------------------------------------------------------------------------------
 *  Modifications
 *  ------------- 
 *  M01      [M01_B  - Indicates beginning of the code change for M01  & M01_E - End of code change for M01]
 *  ----
 *  Description   : Display of Rupee Symbol in Statistic Report
 *  Modified By   : Dhanya P
 *  Modified Date : 21/12/2010
 *  ------------------------------------------------------------------------------------------------------------------------------------------
 */

import java.awt.Dimension;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileOutputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.net.URL;
import java.sql.ResultSet;
import java.text.DecimalFormat;
import java.text.DecimalFormatSymbols;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.GregorianCalendar;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Locale;
import java.util.StringTokenizer;




//import org.apache.pdfbox.pdmodel.PDDocument;
//import org.apache.pdfbox.util.Overlay;
import org.zefer.pd4ml.PD4Constants;
import org.zefer.pd4ml.PD4ML;

import com.tin.tds.bean.FileStatistics;
import com.tin.tds.bean.FileStatistics27A;
import com.tin.tds.bean.PDFFileStatisticData;
import com.tin.tds.FieldValidation;
import com.tin.tds.FileValidatorInterface;
import com.tin.tds.FormValidator;






//Added for barcode generation FVU 4.1
import net.sourceforge.barbecue.Barcode;
import net.sourceforge.barbecue.BarcodeException;
import net.sourceforge.barbecue.BarcodeFactory;
import net.sourceforge.barbecue.BarcodeImageHandler;
import net.sourceforge.barbecue.output.OutputException;

public class FileGenerator implements FileValidatorInterface
{
	Calendar cal = new GregorianCalendar();
	String tab = "^";
    //-------changed for validating the % of structurally valid PAN ---By Manvendra
    public boolean StructurallyinvalidPAN = false ;
//-------------------------------------------------------------
	
    public String uploadType;
//    FileStatistics Obj_fStatistics = new FileStatistics();
 
    
    public void writeToFile(String ERROR_FILE, String text, int errRespFile) throws IOException
	{
		try
		{
			cal = new GregorianCalendar();
			if (text.trim().length() != 0)
			{
				System.out.println(" Entering writeToFile() Method " + cal.getTime());
				PrintWriter out = new PrintWriter(new BufferedWriter(new FileWriter(ERROR_FILE, false)));
				out.println(text);
				out.close();
				cal = new GregorianCalendar();
				System.out.println("Exiting writeToFile() Method " + cal.getTime());
			}
		}
		catch (Exception e)
		{
			System.err.println("Exception in writeToFile() method : "); e.printStackTrace();
			System.out.println("Exception while writing into file - calling errorFileNotGenerated() method");
			//LogInSQLExceptionTable login = new LogInSQLExceptionTable();
			//login.errorFileNotGenerated(ERROR_FILE);
			System.out.println("---Returned from errorFileNotGenerated() -- ");
		}
	}

	public void writeToFile(String fileName, String text, int errRespFile, boolean fileOpened) throws IOException
	{
		try
		{
			cal = new GregorianCalendar();
			if (text.trim().length() != 0)
			{
				PrintWriter out = null;
				//		System.out.println(" Entering writeError/RSPToFile Method " + cal.getTime() +"\t File Name : "+ERROR_FILE);
				if (fileOpened)
				{
					out = new PrintWriter(new BufferedWriter(new FileWriter(fileName, true)));
				}
				else
				{
					out = new PrintWriter(new BufferedWriter(new FileWriter(fileName, false)));
				}
				out.println(text);
				out.close();
				cal = new GregorianCalendar();
				//		System.out.println(" Exiting writeError/RSPToFile Method " + cal.getTime());
			}
		}
		catch (Exception e)
		{
			System.err.println("Exception in writeError/RSPToFile method : " );e.printStackTrace();
			System.out.println("Exception while writing into file - calling errorFileNotGenerated() method");
			//LogInSQLExceptionTable login = new LogInSQLExceptionTable();
			//login.errorFileNotGenerated(fileName);
			System.out.println("---Returned from errorFileNotGenerated() -- ");
		}
	}

	public void writeStatisticFile(String fileName, StringBuffer textBufferString, FileStatistics fStatistics, boolean fileOpenFlag, boolean printPanReport) throws IOException
	{
		try
		{
			cal = new GregorianCalendar();
			String text = textBufferString.toString();
			textBufferString = new StringBuffer();
			if (text.trim().length() != 0)
			{
				System.out.println(" Entering writeStatisticFile() Method " + cal.getTime());
				PrintWriter out = new PrintWriter(new BufferedWriter(new FileWriter(fileName, fileOpenFlag)));
				out.println(text);

				if (!printPanReport)
				{
					out.close();
					out.flush();
					cal = new GregorianCalendar();
					System.out.println(" Exiting writeStatisticFile() Method " + cal.getTime());
					return;
				}

				System.out.println(" Exiting writeStatisticFile() Method " + cal.getTime());
			}
		}
		catch (Exception e)
		{
			System.err.println("Exception in writeStatisticFile() method : ");e.printStackTrace();
		}
	}
	
	public void writePdfFile(String temppdfFileName,String fileName, StringBuffer textBufferString) throws IOException
	{
		try
		{
			
			cal = new GregorianCalendar();
			String text = textBufferString.toString();
			textBufferString = new StringBuffer();
			//String sImagePath=temppdfFileName.substring(0,temppdfFileName.lastIndexOf('\\')+1);
			
			//added below line to for linux /window compatibility start  
			File temppdfFileNamePath = new File(temppdfFileName);	
			String sImagePath = temppdfFileNamePath.getAbsolutePath().substring(0,temppdfFileNamePath.getAbsolutePath().lastIndexOf(File.separator)+1);
			//added below line to for linux /window compatibility end
			
			
			if (text.trim().length() != 0)
			{
				System.out.println(" Entering writePdfFile() Method " + cal.getTime());
				PrintWriter out = new PrintWriter(new BufferedWriter(new FileWriter(temppdfFileName,false)));
				out.println(text);
				System.out.println(" Exiting writePdfFile() Method " + cal.getTime());
				out.close();
				out.flush();
			}
			
			File f = new File(sImagePath+fileName);
			File barcode = new File(sImagePath+"barcode.jpeg");
			java.io.FileOutputStream fos = new java.io.FileOutputStream(f);
			PD4ML pd4ml = new PD4ML();
			File fz = new File(temppdfFileName);
			java.io.FileInputStream fis = new java.io.FileInputStream(fz);
			InputStreamReader isr = new InputStreamReader( fis, "UTF-8" ); 
			URL base = new URL( "file:"+sImagePath );
			pd4ml.adjustHtmlWidth();
			pd4ml.fitPageVertically();
			Dimension d = pd4ml.changePageOrientation(PD4Constants.A4);
			pd4ml.setPageSize(d);
			pd4ml.render( isr, fos,base );
			fz.delete();
			if(barcode.exists())
				barcode.delete();
		
		
		
		
		}
		catch (Exception e)
		{
			System.err.println("Exception in writePdfFile() method : ");e.printStackTrace();
		}
	}

	public StringBuffer createProvisionalReceipt(FileStatistics pReceipt, StringBuffer toReturn)
	{
		boolean isTanChange = false;

		try
		{ // FORMAT OF RECEIPT - START
			toReturn.append("<HTML> <HEAD><TITLE></TITLE></HEAD>");
			toReturn.append("<BODY>");
			if (pReceipt.getForm_No().equals(FORM_27EQ))
			{
				toReturn.append("<H3 ALIGN=CENTER> TCS - Provisional Receipt - Batch Number " + pReceipt.getBatch_No() + "</H3>");
			}
			else
			{
				toReturn.append("<H3 ALIGN=CENTER> TDS - Provisional Receipt - Batch Number " + pReceipt.getBatch_No() + "</H3>");
			}

			toReturn.append(
				"<TABLE BORDER=1 BORDERCOLOR=\"000000\" CELLSPACING=0 CELLPADDING=0 style='border-collapse:collapse; border:none;mso-border-alt:solid windowtext .5pt;mso-padding-alt:0in 5.4pt 0in 5.4pt'>"
					+ "<TR>"
					+ "<TD>");

			toReturn.append(
				"<TABLE BORDER=1 BORDERCOLOR=\"000000\" CELLSPACING=0 CELLPADDING=0 style='border-collapse:collapse; border:none;mso-border-alt:solid windowtext .5pt;mso-padding-alt:0in 5.4pt 0in 5.4pt'>");
			toReturn.append("<TR>");
			toReturn.append("<TD WIDTH=150 ALIGN=RIGHT VALIGN=TOP TEXTCOLOR=\"#F4CE85\"><B>" + "Receipt Number" + "</B></TD>");
			if (pReceipt.getForm_No().equals(FORM_27EQ))
			{

				if (pReceipt.getTransaction_Type().equals(TRANSACTIONTYPE_CORRECTION_BATCH) && (!pReceipt.getTAN().equals(pReceipt.getLastTAN())))
				{
					isTanChange = true;
					toReturn.append("<TD WIDTH=425 ALIGN=LEFT VALIGN=TOP><B> " + "Name of Collector" + "</B></TD>");
					toReturn.append("<TD WIDTH=425 ALIGN=LEFT VALIGN=TOP><B> " + "New Name of Collector" + "</B></TD>");
				}
				else
				{
					toReturn.append("<TD WIDTH=850 ALIGN=LEFT VALIGN=TOP><B> " + "Name of Collector" + "</B></TD>");
				}
			}
			else
			{
				// 24Q, 26Q, 27Q
				if (pReceipt.getTransaction_Type().equals(TRANSACTIONTYPE_CORRECTION_BATCH) && (!pReceipt.getTAN().equals(pReceipt.getLastTAN())))
				{
					isTanChange = true;
					toReturn.append("<TD WIDTH=425 ALIGN=LEFT VALIGN=TOP><B> " + "Name of Deductor" + "</B></TD>");
					toReturn.append("<TD WIDTH=425 ALIGN=LEFT VALIGN=TOP><B> " + "New Name of Deductor" + "</B></TD>");
				}
				else
				{
					toReturn.append("<TD WIDTH=850 ALIGN=LEFT VALIGN=TOP><B> " + "Name of Deductor" + "</B></TD>");
				}
			}
			toReturn.append("</TR>");
			toReturn.append("<TR>");
			toReturn.append("<TD ALIGN=RIGHT VALIGN=TOP ><FONT COLOR=\"RED\"> <B> " + pReceipt.getReceipt_Number() + "</B></FONT></TD>");
			if (pReceipt.getTransaction_Type().equals(TRANSACTIONTYPE_CORRECTION_BATCH) && (!pReceipt.getTAN().equals(pReceipt.getLastTAN())))
			{
				isTanChange = true;
				toReturn.append("<TD  ALIGN=LEFT VALIGN=TOP> " + pReceipt.getName_of_Last_Deductor() + " </TD>");
				toReturn.append("<TD  ALIGN=LEFT VALIGN=TOP> " + pReceipt.getName_of_Deductor() + " </TD>");
			}
			else
			{
				toReturn.append("<TD  ALIGN=LEFT VALIGN=TOP> " + pReceipt.getName_of_Deductor() + " </TD>");
			}

			toReturn.append("</TR>");

			//******************
			toReturn.append("</TABLE>");
			toReturn.append("<BR>");
			toReturn.append(
				"<TABLE BORDER=1 BORDERCOLOR=\"000000\" CELLSPACING=0 CELLPADDING=0 style='border-collapse:collapse; border:none;mso-border-alt:solid windowtext .5pt;mso-padding-alt:0in 5.4pt 0in 5.4pt'>");
			//******************

			toReturn.append("<TR>");
			toReturn.append("<TD WIDTH=150 ALIGN=LEFT VALIGN=TOP><B>" + "Date" + "</B></TD>");
			if (pReceipt.getTransaction_Type().equals(TRANSACTIONTYPE_CORRECTION_BATCH) && (!pReceipt.getTAN().equals(pReceipt.getLastTAN())))
			{
				isTanChange = true;
				toReturn.append("<TD WIDTH=125 ALIGN=LEFT VALIGN=TOP><B> " + "TAN" + "</B></TD>");
				toReturn.append("<TD WIDTH=125 ALIGN=LEFT VALIGN=TOP><B> " + "New TAN*" + "</B></TD>");
			}
			else
			{
				toReturn.append("<TD WIDTH=250 ALIGN=LEFT VALIGN=TOP><B> " + "TAN" + "</B></TD>");
			}
			toReturn.append("<TD WIDTH=100 ALIGN=LEFT VALIGN=TOP ><B> " + "AO Code" + "</B></TD>");
			toReturn.append("<TD WIDTH=100 ALIGN=LEFT VALIGN=TOP><B> " + "Form No." + "</B></TD>");
			toReturn.append("<TD WIDTH=100 ALIGN=LEFT VALIGN=TOP><B> " + "Upload Type" + "</B></TD>");
			toReturn.append("<TD WIDTH=150 ALIGN=LEFT VALIGN=TOP><B> " + "Transaction Type " + "</B></TD>");
			toReturn.append("<TD WIDTH=150 ALIGN=LEFT VALIGN=TOP><B> " + "Financial Year and Periodicity" + "</B></TD>");

			if (pReceipt.getTransaction_Type().equals(TRANSACTIONTYPE_CORRECTION_BATCH)
				|| pReceipt.getTransaction_Type().equals(TRANSACTIONTYPE_CANCELLATION_BATCH)
				|| pReceipt.getTransaction_Type().equals(TRANSACTIONTYPE_CANCELLATION_BATCH_TFC))
			{ // C1, Y
				toReturn.append("<TD WIDTH=150 ALIGN=RIGHT VALIGN=TOP><B> " + "Upload Fee (Rs.)" + "</B></TD>");
			}
			toReturn.append("</TR>");

			toReturn.append("<TR>");
			toReturn.append("<TD ALIGN=LEFT VALIGN=TOP> " + setDateFormat(pReceipt.getDate()) + "</TD>");
			if (pReceipt.getTransaction_Type().equals(TRANSACTIONTYPE_CORRECTION_BATCH) && (!pReceipt.getTAN().equals(pReceipt.getLastTAN())))
			{
				toReturn.append("<TD ALIGN=LEFT VALIGN=TOP><B> " + pReceipt.getLastTAN() + "</B></TD>");
				toReturn.append("<TD ALIGN=LEFT VALIGN=TOP><B> " + pReceipt.getTAN() + "</B></TD>");
			}
			else
			{
				toReturn.append("<TD ALIGN=LEFT VALIGN=TOP><B> " + pReceipt.getTAN() + "</B></TD>");
			}

			toReturn.append("<TD ALIGN=LEFT VALIGN=TOP > " + pReceipt.getAO_Code() + "</TD>");
			toReturn.append("<TD ALIGN=LEFT VALIGN=TOP > " + pReceipt.getForm_No() + "</TD>");

			if (pReceipt.getUpload_Type().equals(UPLOADTYPE_REGULAR))
				toReturn.append("<TD ALIGN=LEFT VALIGN=TOP >" + "Regular (R)" + "</TD>");
			else
				toReturn.append("<TD ALIGN=LEFT VALIGN=TOP >" + "Correction (C)" + "</TD>");

			if (pReceipt.getUpload_Type().equals(UPLOADTYPE_REGULAR))
			{
				toReturn.append("<TD ALIGN=LEFT VALIGN=TOP >" + "NA" + "</TD>");
			}
			else
			{
				// FOR Transaction Type - START
				if (pReceipt.getTransaction_Type().equals(TRANSACTIONTYPE_CORRECTION_BATCH))
					toReturn.append("<TD ALIGN=LEFT VALIGN=TOP > " + TRANSACTIONTYPE_CORRECTION_BATCH_LABEL + "</TD>");
				else if (pReceipt.getTransaction_Type().equals(TRANSACTIONTYPE_ADDITION_CHALLAN))
					toReturn.append("<TD ALIGN=LEFT VALIGN=TOP > " + TRANSACTIONTYPE_ADDITION_CHALLAN_LABEL + "</TD>");
				else if (pReceipt.getTransaction_Type().equals(TRANSACTIONTYPE_CORRECTION_CHALLAN))
					toReturn.append("<TD ALIGN=LEFT VALIGN=TOP > " + TRANSACTIONTYPE_CORRECTION_CHALLAN_LABEL + "</TD>");
				else if (pReceipt.getTransaction_Type().equals(TRANSACTIONTYPE_CORRECTION_DEDUCTEE))
					toReturn.append("<TD ALIGN=LEFT VALIGN=TOP > " + TRANSACTIONTYPE_CORRECTION_DEDUCTEE_LABEL + "</TD>");
				else if (pReceipt.getTransaction_Type().equals(TRANSACTIONTYPE_CORRECTION_SALARY))
					toReturn.append("<TD ALIGN=LEFT VALIGN=TOP > " + TRANSACTIONTYPE_CORRECTION_SALARY_LABEL + "</TD>");
				else if (pReceipt.getTransaction_Type().equals(TRANSACTIONTYPE_CORRECTION_PAN))
					toReturn.append("<TD ALIGN=LEFT VALIGN=TOP > " + TRANSACTIONTYPE_CORRECTION_PAN_LABEL + "</TD>");
				else if (pReceipt.getTransaction_Type().equals(TRANSACTIONTYPE_CORRECTION_CANCELLATION))
					toReturn.append("<TD ALIGN=LEFT VALIGN=TOP > " + TRANSACTIONTYPE_CORRECTION_CANCELLATION_LABEL + "</TD>");
				else if (pReceipt.getTransaction_Type().equals(TRANSACTIONTYPE_CANCELLATION_BATCH))
					toReturn.append("<TD ALIGN=LEFT VALIGN=TOP > " + TRANSACTIONTYPE_CANCELLATION_BATCH_LABEL + "</TD>");
				else if (pReceipt.getTransaction_Type().equals(TRANSACTIONTYPE_REPLACE_SALARY))
					toReturn.append("<TD ALIGN=LEFT VALIGN=TOP > " + TRANSACTIONTYPE_REPLACE_SALARY_LABEL + "</TD>");
				else if (pReceipt.getTransaction_Type().equals(TRANSACTIONTYPE_CANCELLATION_BATCH_TFC))
					toReturn.append("<TD ALIGN=LEFT VALIGN=TOP > " + TRANSACTIONTYPE_CANCELLATION_BATCH_LABEL_TFC + "</TD>");

				// FOR Transaction Type - END
			}
			try
			{
				String token = pReceipt.getFinancial_Year();
				toReturn.append("<TD ALIGN=LEFT VALIGN=TOP >" + token.substring(0, 4) + "-" + token.substring(4, token.length()) + "  " + pReceipt.getPeriodicity() + "</TD>");
			}
			catch (Exception e)
			{
				toReturn.append("<TD></TD>");
				System.err.println("Exception in FileGenerator.java createProvisionalReceipt() Financial year is not in specified format  : ");
				e.printStackTrace();
			}

			if (pReceipt.getTransaction_Type().equals(TRANSACTIONTYPE_CORRECTION_BATCH)
				|| pReceipt.getTransaction_Type().equals(TRANSACTIONTYPE_CANCELLATION_BATCH)
				|| pReceipt.getTransaction_Type().equals(TRANSACTIONTYPE_CANCELLATION_BATCH_TFC))
			{ // C1, Y, Y1
				toReturn.append("<TD  ALIGN=RIGHT VALIGN=TOP>" + pReceipt.getUpload_Fee() + "</TD>");
			}
			toReturn.append("</TR>");
			toReturn.append("</TABLE>");
			toReturn.append("<BR>");

			//****************** CHANGES OF PR - 09-09-2005 - START

			if (pReceipt.getTransaction_Type().equals(TRANSACTIONTYPE_CORRECTION_BATCH)
				|| pReceipt.getTransaction_Type().equals(TRANSACTIONTYPE_CANCELLATION_BATCH)
				|| pReceipt.getTransaction_Type().equals(TRANSACTIONTYPE_CANCELLATION_BATCH_TFC))
			{ // C1, Y, Y1
				toReturn.append(
					"<TABLE BORDER=1 BORDERCOLOR=\"000000\" CELLSPACING=0 CELLPADDING=0 style='border-collapse:collapse; border:none;mso-border-alt:solid windowtext .5pt;mso-padding-alt:0in 5.4pt 0in 5.4pt'>");
				//******************

				toReturn.append("<TR>");
				toReturn.append("<TD WIDTH=1000>");
				toReturn.append(" </B><BR>");
				toReturn.append("Service Tax Registration No.:<B> AAACN2082NST001 - ST/MUM/DIV-III/BAS/2847 </B>");
				toReturn.append("<BR>");
				toReturn.append("<B>National Securities Depository Limited (e-TDS intermediary)</B>");
				toReturn.append("<BR>");
				if (isTanChange == true)
				{
					toReturn.append("<B>");
					toReturn.append("* TAN correction is subjected to approval from Income Tax Department");
					toReturn.append("<BR><BR>");
					toReturn.append("</B>");
				}
				toReturn.append("<B>");
				toReturn.append("<I>This is a computer generated Provisional Receipt, hence signature not required.");
				toReturn.append("</I>");
				toReturn.append("</B>");
				toReturn.append("</TD>");
				toReturn.append("</TR>");
				toReturn.append("</TABLE>");
			}
			else if (pReceipt.getTransaction_Type().equals(TRANSACTIONTYPE_CORRECTION_CHALLAN) || pReceipt.getTransaction_Type().equals(TRANSACTIONTYPE_CORRECTION_CANCELLATION))
			{
				toReturn.append(
					"<TABLE BORDER=1 BORDERCOLOR=\"000000\" CELLSPACING=0 CELLPADDING=0 style='border-collapse:collapse; border:none;mso-border-alt:solid windowtext .5pt;mso-padding-alt:0in 5.4pt 0in 5.4pt'>");
				toReturn.append("<TR>");
				toReturn.append("<TD WIDTH=350 ALIGN=RIGHT VALIGN=TOP><B> " + "No. of Challans/Transfer Vouchers" + "</B></CENTER></TD>");
				toReturn.append("<TD WIDTH=400 ALIGN=RIGHT VALIGN=TOP><B> " + "Total Challan/Transfer Voucher Amount (Rs.)" + "</B></CENTER></TD>");

				toReturn.append("<TD WIDTH=250 ALIGN=RIGHT VALIGN=TOP><B> " + "Upload Fee (Rs.)" + "</B></TD>");

				toReturn.append("</TR>");

				toReturn.append("<TR>");
				toReturn.append("<TD  ALIGN=RIGHT VALIGN=TOP>" + pReceipt.getNo_of_challans() + "</TD>");
				toReturn.append("<TD  ALIGN=RIGHT VALIGN=TOP>" + pReceipt.getTotal_Challan_Amount() + "</TD>");
				toReturn.append("<TD  ALIGN=RIGHT VALIGN=TOP>" + pReceipt.getUpload_Fee() + "</TD>");
				toReturn.append("</TR>");

				//******************
				toReturn.append("</TABLE>");
				toReturn.append("<BR>");
				toReturn.append(
					"<TABLE BORDER=1 BORDERCOLOR=\"000000\" CELLSPACING=0 CELLPADDING=0 style='border-collapse:collapse; border:none;mso-border-alt:solid windowtext .5pt;mso-padding-alt:0in 5.4pt 0in 5.4pt'>");
				//******************

				toReturn.append("<TR>");
				toReturn.append("<TD WIDTH=1000>");
				toReturn.append(" </B><BR>");
				toReturn.append("Service Tax Registration No.:<B> AAACN2082NST001 - ST/MUM/DIV-III/BAS/2847 </B>");
				toReturn.append("<BR>");
				toReturn.append("<B>National Securities Depository Limited (e-TDS intermediary)</B>");
				toReturn.append("<BR>");
				if (isTanChange == true)
				{
					toReturn.append("<B>");
					toReturn.append("* TAN correction is subjected to approval from Income Tax Department");
					toReturn.append("<BR><BR>");
					toReturn.append("</B>");

				}
				toReturn.append("<B>");
				toReturn.append("<I>This is a computer generated Provisional Receipt, hence signature not required.");
				toReturn.append("</I>");
				toReturn.append("</B>");
				toReturn.append("</TD>");
				toReturn.append("</TR>");
				toReturn.append("</TABLE>");

			}
			else if (pReceipt.getTransaction_Type().equals(TRANSACTIONTYPE_CORRECTION_DEDUCTEE))
			{ // C3
				toReturn.append(
					"<TABLE BORDER=1 BORDERCOLOR=\"000000\" CELLSPACING=0 CELLPADDING=0 style='border-collapse:collapse; border:none;mso-border-alt:solid windowtext .5pt;mso-padding-alt:0in 5.4pt 0in 5.4pt'>");
				toReturn.append("<TR>");
				// commented on 19-May-2005
				toReturn.append("<TD WIDTH=250 ALIGN=RIGHT VALIGN=TOP><B> " + "No. of Challans/Transfer Vouchers" + "</B></CENTER></TD>");
				toReturn.append("<TD WIDTH=250 ALIGN=RIGHT VALIGN=TOP><B> " + "Total Challan/Transfer Voucher Amount (Rs.)" + "</B></CENTER></TD>");

				if (pReceipt.getForm_No().equals(FORM_27EQ))
				{
					toReturn.append("<TD WIDTH=200 ALIGN=RIGHT VALIGN=TOP><B> " + "No. of Party Records" + "</B></TD>");
					toReturn.append("<TD WIDTH=200 ALIGN=RIGHT VALIGN=TOP><B> " + "Total Value of Purchase (Rs.)" + "</B></TD>");
					toReturn.append("<TD WIDTH=100 ALIGN=RIGHT VALIGN=TOP><B> " + "Upload Fee (Rs.)" + "</B></TD>");

				}
				else
				{ // means 24Q, 26Q, 27Q
					toReturn.append("<TD WIDTH=150 ALIGN=RIGHT VALIGN=TOP><B> " + "No. of Deductee Records" + "</B></TD>");
					toReturn.append("<TD WIDTH=250 ALIGN=RIGHT VALIGN=TOP><B> " + "Upload Fee (Rs.)" + "</B></TD>");

				}

				toReturn.append("</TR>");
				toReturn.append("<TR>");
				// commented on 19-May-2005
				toReturn.append("<TD  ALIGN=RIGHT VALIGN=TOP>" + pReceipt.getNo_of_challans() + "</TD>");
				toReturn.append("<TD  ALIGN=RIGHT VALIGN=TOP>" + pReceipt.getTotal_Challan_Amount() + "</TD>");
				toReturn.append("<TD  ALIGN=RIGHT VALIGN=TOP>" + pReceipt.getNo_of_Deductee_Records() + "</TD>");

				if (pReceipt.getForm_No().equals(FORM_27EQ))
				{
					toReturn.append("<TD  ALIGN=RIGHT VALIGN=TOP>" + pReceipt.getTotal_Value_of_Purchase() + "</TD>");
				}
				else
				{
					// means 24Q, 26Q, 27Q
				}
				toReturn.append("<TD  ALIGN=RIGHT VALIGN=TOP>" + pReceipt.getUpload_Fee() + "</TD>");
				toReturn.append("</TR>");

				toReturn.append("</TABLE>");
				toReturn.append("<BR>");
				//*************************************************************
				toReturn.append(
					"<TABLE BORDER=1 BORDERCOLOR=\"000000\" CELLSPACING=0 CELLPADDING=0 style='border-collapse:collapse; border:none;mso-border-alt:solid windowtext .5pt;mso-padding-alt:0in 5.4pt 0in 5.4pt'>");
				toReturn.append("<TR>");
				if (pReceipt.getTransaction_Type().equals(TRANSACTIONTYPE_CORRECTION_DEDUCTEE))
				{
					toReturn.append("<TD valign=top width=250 ><B> " + "Particulars " + "</B></TD>");
				}

				if (pReceipt.getForm_No().equals(FORM_27EQ))
				{
					toReturn.append("<TD valign=top width=250 style='text-align:right'><B> " + "Amount of Collection / Debited (Rs.)" + "</B></TD>");
					toReturn.append("<TD valign=top width=250 style='text-align:right'><B> " + "Total Income Tax Collected at Source (Rs.)" + "</B></TD>");
				}
				else
				{
					toReturn.append("<TD valign=top width=250 style='text-align:right'><B> " + "Amount of Payment / Credit (Rs.)" + "</B></TD>");
					toReturn.append("<TD valign=top width=250 style='text-align:right'><B> " + "Total Income Tax Deducted at Source (Rs.)" + "</B></TD>");
				}

				toReturn.append("<TD valign=top width=250 style='text-align:right'><B> " + "Total Tax Deposited as per Deductee Annexure (Rs.)" + "</B></TD>");

				toReturn.append("</TR>");

				toReturn.append("<TR>");
				toReturn.append("<TD  ><B>" + "Added (a)" + "</B></TD>");
				toReturn.append("<TD  ALIGN=RIGHT >" + pReceipt.getTotal_Amount_paid_credited_Add_Mode() + "</TD>");
				toReturn.append("<TD  ALIGN=RIGHT >" + pReceipt.getTotal_Tax_Deducted_Add_Mode() + "</TD>");
				toReturn.append("<TD  ALIGN=RIGHT >" + pReceipt.getTotal_Amount_deposited_Add_Mode() + "</TD>");
				toReturn.append("</TR>");

				toReturn.append("<TR>");
				toReturn.append("<TD  ><B>" + "Updated (b)" + "</B></TD>");
				toReturn.append("<TD  ALIGN=RIGHT >" + pReceipt.getTotal_Amount_paid_credited_Updt_Mode() + "</TD>");
				toReturn.append("<TD  ALIGN=RIGHT >" + pReceipt.getTotal_Tax_Deducted_Updt_Mode() + "</TD>");
				toReturn.append("<TD  ALIGN=RIGHT >" + pReceipt.getTotal_Amount_deposited_Updt_Mode() + "</TD>");
				toReturn.append("</TR>");

				toReturn.append("<TR>");
				toReturn.append("<TD  ><B>" + "Deleted (c)" + "</B></TD>");
				toReturn.append("<TD  ALIGN=RIGHT >" + "NA" + "</TD>");
				toReturn.append("<TD  ALIGN=RIGHT >" + pReceipt.getTotal_Tax_Deducted_Del_Mode() + "</TD>");
				toReturn.append("<TD  ALIGN=RIGHT >" + pReceipt.getTotal_Amount_deposited_Del_Mode() + "</TD>");
				toReturn.append("</TR>");

				toReturn.append("<TR>");
				toReturn.append("<TD  ><B>" + "Total (a + b + c)" + "</B></TD>");

				// Total of Total_Amount_paid_credited of Mode Update and Add
				double val1 = 0.00;
				double val2 = 0.00;
				double val3 = 0.00;
				String outputValue = null;
				if (!pReceipt.getTotal_Amount_paid_credited_Add_Mode().equals("-"))
				{
					val1 = Double.parseDouble(pReceipt.getTotal_Amount_paid_credited_Add_Mode().trim());
				}

				if (!pReceipt.getTotal_Amount_paid_credited_Updt_Mode().equals("-"))
				{
					val2 = Double.parseDouble(pReceipt.getTotal_Amount_paid_credited_Updt_Mode().trim());
				}

				val3 = val1 + val2;
				val3 = Math.round((double) (val3 * 100)) / 100.0;
				FieldValidation fvObj = new FieldValidation();
				outputValue = fvObj.changeNumberFormat(val3);

				toReturn.append("<TD  ALIGN=RIGHT >" + outputValue + "</TD>");
				// Total of Total_Amount_paid_credited of Mode Update and Add

				// Total of Total_Tax_Deducted of Mode Update, Add and Delete
				val1 = 0.00;
				val2 = 0.00;
				val3 = 0.00;
				double val4 = 0.00;

				if (!pReceipt.getTotal_Tax_Deducted_Add_Mode().equals("-"))
				{
					val1 = Double.parseDouble(pReceipt.getTotal_Tax_Deducted_Add_Mode().trim());
				}

				if (!pReceipt.getTotal_Tax_Deducted_Updt_Mode().equals("-"))
				{
					val2 = Double.parseDouble(pReceipt.getTotal_Tax_Deducted_Updt_Mode().trim());
				}

				if (!pReceipt.getTotal_Tax_Deducted_Del_Mode().equals("-"))
				{
					val3 = Double.parseDouble(pReceipt.getTotal_Tax_Deducted_Del_Mode().trim());
				}

				val4 = val1 + val2 + val3;
				val4 = Math.round((double) (val4 * 100)) / 100.0;

				outputValue = null;
				outputValue = fvObj.changeNumberFormat(val4);

				toReturn.append("<TD  ALIGN=RIGHT >" + outputValue + "</TD>");
				// Total of Total_Tax_Deducted of Mode Update, Add and Delete

				// Total of Total_Amount_deposited of Mode Update, Add and Delete
				val1 = 0.00;
				val2 = 0.00;
				val3 = 0.00;
				val4 = 0.00;
				if (!pReceipt.getTotal_Amount_deposited_Add_Mode().equals("-"))
				{
					val1 = Double.parseDouble(pReceipt.getTotal_Amount_deposited_Add_Mode().trim());
				}

				if (!pReceipt.getTotal_Amount_deposited_Updt_Mode().equals("-"))
				{
					val2 = Double.parseDouble(pReceipt.getTotal_Amount_deposited_Updt_Mode().trim());
				}

				if (!pReceipt.getTotal_Amount_deposited_Del_Mode().equals("-"))
				{
					val3 = Double.parseDouble(pReceipt.getTotal_Amount_deposited_Del_Mode().trim());
				}

				val4 = val1 + val2 + val3;
				val4 = Math.round((double) (val4 * 100)) / 100.0;
				outputValue = null;
				outputValue = fvObj.changeNumberFormat(val4);

				toReturn.append("<TD  ALIGN=RIGHT >" + outputValue + "</TD>");
				// Total of Total_Amount_deposited of Mode Update, Add and Delete

				toReturn.append("</TR>");

				toReturn.append("</TABLE>");
				toReturn.append("<BR>");
				// Table 5 ENDS

				//*************************************************************
				toReturn.append(
					"<TABLE BORDER=1 BORDERCOLOR=\"000000\" CELLSPACING=0 CELLPADDING=0 style='border-collapse:collapse; border:none;mso-border-alt:solid windowtext .5pt;mso-padding-alt:0in 5.4pt 0in 5.4pt'>");
				//******************
				toReturn.append("<TR>");
				toReturn.append("<TD WIDTH=1000>");
				toReturn.append("<BR>");
				toReturn.append("Deficiency (ies): ");
				toReturn.append("<BR>");
				toReturn.append("1) <B>" + pReceipt.getNo_of_PAN_Applied() + " case(s)</B> where deductee(s) has applied for <B>'Permanent Account Number'</B> <BR>");
				toReturn.append("2) <B>" + pReceipt.getNo_of_PAN_NotAvailabble() + " case(s)</B> where <B>'Permanent Account Number'</B> is not available for deductee(s) <BR>");
				toReturn.append("3) <B>" + pReceipt.getNo_of_PAN_Invalid() + " case(s)</B> where <B>'Permanent Account Number'</B> of deductee(s) is incorrect <BR>");
				toReturn.append("<BR>");
				toReturn.append("Please remove the deficiency(ies) within <B>7 days</B> by filling a revised return.");
				toReturn.append("<BR>");
				toReturn.append("<BR>");

				toReturn.append("<B> Last Deductee (LD) Detail Record in Challan(s) : </B>");
				if (!pReceipt.getNo_of_LD().equals(""))
				{
					StringTokenizer str = new StringTokenizer(pReceipt.getNo_of_LD(), "&");
					int no_of_token = str.countTokens();
					for (int i = 0; i < no_of_token; i++)
					{
						if (i < (no_of_token - 1))
							toReturn.append(str.nextToken() + ", ");
						else
							toReturn.append(str.nextToken());
					}
					toReturn.append(" (eg. LD1=2 means \"Last Deductee detail record no. of Challan 1 is 2\")");
					toReturn.append(" <BR>");
				}
				else
				{
					toReturn.append(" - <BR>");
				}
				toReturn.append(" </B><BR>");
				toReturn.append("Service Tax Registration No.:<B> AAACN2082NST001 - ST/MUM/DIV-III/BAS/2847 </B>");
				toReturn.append("<BR>");
				toReturn.append("<B>National Securities Depository Limited (e-TDS intermediary)</B>");
				toReturn.append("<BR>");
				if (isTanChange == true)
				{
					toReturn.append("<B>");
					toReturn.append("* TAN correction is subjected to approval from Income Tax Department");
					toReturn.append("<BR><BR>");
					toReturn.append("</B>");
				}
				toReturn.append("<B>");
				toReturn.append("<I>This is a computer generated Provisional Receipt, hence signature not required.");
				toReturn.append("</I>");
				toReturn.append("</B>");
				toReturn.append("</TD>");
				toReturn.append("</TR>");
				toReturn.append("</TABLE>");
			}
			else if (pReceipt.getTransaction_Type().equals(TRANSACTIONTYPE_CORRECTION_SALARY) || pReceipt.getTransaction_Type().equals(TRANSACTIONTYPE_REPLACE_SALARY))
			{
				toReturn.append(
					"<TABLE BORDER=1 BORDERCOLOR=\"000000\" CELLSPACING=0 CELLPADDING=0 style='border-collapse:collapse; border:none;mso-border-alt:solid windowtext .5pt;mso-padding-alt:0in 5.4pt 0in 5.4pt'>");
				toReturn.append("<TR>");
				toReturn.append("<TD WIDTH=450 ALIGN=RIGHT VALIGN=TOP><B> " + "No. of Salary Detail Records" + "</B></TD>");
				toReturn.append("<TD WIDTH=450 ALIGN=RIGHT VALIGN=TOP><B> " + "Batch Total of - Gross Total Income as per Salary Detail (Rs.)" + "</B></TD>");

				toReturn.append("<TD WIDTH=100 ALIGN=RIGHT VALIGN=TOP><B> " + "Upload Fee (Rs.)" + "</B></TD>");

				toReturn.append("</TR>");
				toReturn.append("<TR>");

				toReturn.append("<TD  ALIGN=RIGHT VALIGN=TOP>" + pReceipt.getNo_of_Salary_Detail() + "</TD>");
				toReturn.append("<TD  ALIGN=RIGHT VALIGN=TOP>" + pReceipt.getTotal_Income_As_Per_SD() + "</TD>");
				toReturn.append("<TD  ALIGN=RIGHT VALIGN=TOP>" + pReceipt.getUpload_Fee() + "</TD>");
				toReturn.append("</TR>");

				//******************
				toReturn.append("</TABLE>");
				toReturn.append(
					"<TABLE BORDER=1 BORDERCOLOR=\"000000\" CELLSPACING=0 CELLPADDING=0 style='border-collapse:collapse; border:none;mso-border-alt:solid windowtext .5pt;mso-padding-alt:0in 5.4pt 0in 5.4pt'>");
				//******************

				toReturn.append("<TR>");
				toReturn.append("<TD WIDTH=1000>");
				toReturn.append("<BR>");
				toReturn.append("Deficiency (ies): ");
				toReturn.append("<BR>");
				toReturn.append("1) <B>" + pReceipt.getNo_of_PAN_Applied() + " case(s)</B> where deductee(s) has applied for <B>'Permanent Account Number'</B> <BR>");
				toReturn.append("2) <B>" + pReceipt.getNo_of_PAN_NotAvailabble() + " case(s)</B> where <B>'Permanent Account Number'</B> is not available for deductee(s) <BR>");
				toReturn.append("3) <B>" + pReceipt.getNo_of_PAN_Invalid() + " case(s)</B> where <B>'Permanent Account Number'</B> of deductee(s) is incorrect <BR>");
				toReturn.append("<BR>");
				toReturn.append("Please remove the deficiency(ies) within <B>7 days</B> by filling a revised return.");
				toReturn.append("<BR>");
				toReturn.append("<BR>");
				if (!pReceipt.getNo_of_LS().equals(""))
				{
					toReturn.append("<B> Last Salary (LS) Details Record Number in Batch :  </B>  " + pReceipt.getNo_of_LS() + "<BR>");
				}
				else
				{
					toReturn.append("<B> Last Salary (LS) Details Record Number in Batch :  </B> - <BR>");
				}
				toReturn.append(" </B><BR>");
				toReturn.append("Service Tax Registration No.:<B> AAACN2082NST001 - ST/MUM/DIV-III/BAS/2847 </B>");
				toReturn.append("<BR>");
				toReturn.append("<B>National Securities Depository Limited (e-TDS intermediary)</B>");
				toReturn.append("<BR>");
				if (isTanChange == true)
				{
					toReturn.append("<B>");
					toReturn.append("* TAN correction is subjected to approval from Income Tax Department");
					toReturn.append("<BR><BR>");
					toReturn.append("</B>");
				}
				toReturn.append("<B>");
				toReturn.append("<I>This is a computer generated Provisional Receipt, hence signature not required.");
				toReturn.append("</I>");
				toReturn.append("</B>");
				toReturn.append("</TD>");
				toReturn.append("</TR>");
				toReturn.append("</TABLE>");

			}
			else if (pReceipt.getTransaction_Type().equals(TRANSACTIONTYPE_CORRECTION_PAN))
			{
				toReturn.append(
					"<TABLE BORDER=1 BORDERCOLOR=\"000000\" CELLSPACING=0 CELLPADDING=0 style='border-collapse:collapse; border:none;mso-border-alt:solid windowtext .5pt;mso-padding-alt:0in 5.4pt 0in 5.4pt'>");
				toReturn.append("<TR>");
				if (pReceipt.getForm_No().equals(FORM_24Q))
				{
					toReturn.append("<TD WIDTH=250 ALIGN=RIGHT VALIGN=TOP><B> " + "No. of Challans/Transfer Vouchers" + "</B></CENTER></TD>");
					toReturn.append("<TD WIDTH=150 ALIGN=RIGHT VALIGN=TOP><B> " + "No. of Deductee Records" + "</B></TD>");
					toReturn.append("<TD WIDTH=250 ALIGN=RIGHT VALIGN=TOP><B> " + "No. of Salary Detail Records" + "</B></TD>");

				}
				else
				{ // means 26Q, 27Q, 27EQ
					toReturn.append("<TD WIDTH=400 ALIGN=RIGHT VALIGN=TOP><B> " + "No. of Challans/Transfer Vouchers" + "</B></CENTER></TD>");
					toReturn.append("<TD WIDTH=400 ALIGN=RIGHT VALIGN=TOP><B> " + "No. of Deductee Records" + "</B></TD>");
				}
				toReturn.append("<TD WIDTH=200 ALIGN=RIGHT VALIGN=TOP><B> " + "Upload Fee (Rs.)" + "</B></TD>");

				toReturn.append("</TR>");
				toReturn.append("<TR>");
				// commented on 19-May-2005
				toReturn.append("<TD  ALIGN=RIGHT VALIGN=TOP>" + pReceipt.getNo_of_challans() + "</TD>");
				toReturn.append("<TD  ALIGN=RIGHT VALIGN=TOP>" + pReceipt.getNo_DD_C5() + "</TD>");

				if (pReceipt.getForm_No().equals(FORM_24Q))
				{
					toReturn.append("<TD  ALIGN=RIGHT VALIGN=TOP>" + pReceipt.getNo_SD_C5() + "</TD>");
					System.out.println("No_of_Salary_Detail : " + pReceipt.getNo_SD_C5());
				}
				toReturn.append("<TD  ALIGN=RIGHT VALIGN=TOP>" + pReceipt.getUpload_Fee() + "</TD>");
				toReturn.append("</TR>");
				toReturn.append("</TABLE>");

				toReturn.append("<BR>");
				toReturn.append(
					"<TABLE BORDER=1 BORDERCOLOR=\"000000\" CELLSPACING=0 CELLPADDING=0 style='border-collapse:collapse; border:none;mso-border-alt:solid windowtext .5pt;mso-padding-alt:0in 5.4pt 0in 5.4pt'>");

				toReturn.append("<TR>");
				toReturn.append("<TD WIDTH=1000>");
				toReturn.append(" </B><BR>");
				toReturn.append("Service Tax Registration No.:<B> AAACN2082NST001 - ST/MUM/DIV-III/BAS/2847 </B>");
				toReturn.append("<BR>");
				toReturn.append("<B>National Securities Depository Limited (e-TDS intermediary)</B>");
				toReturn.append("<BR>");
				toReturn.append("<B><I>This is a computer generated Provisional Receipt, hence signature not required.</I></B>");
				toReturn.append("</TD>");
				toReturn.append("</TR>");
				toReturn.append("</TABLE>");

			}
			else
			{ // means regular
				toReturn.append(
					"<TABLE BORDER=1 BORDERCOLOR=\"000000\" CELLSPACING=0 CELLPADDING=0 style='border-collapse:collapse; border:none;mso-border-alt:solid windowtext .5pt;mso-padding-alt:0in 5.4pt 0in 5.4pt'>");
				toReturn.append("<TR>");
				// commented on 19-May-2005
				if (!pReceipt.getTransaction_Type().equals(TRANSACTIONTYPE_CORRECTION_SALARY) && !pReceipt.getTransaction_Type().equals(TRANSACTIONTYPE_REPLACE_SALARY))
				{
					toReturn.append("<TD WIDTH=125 ALIGN=RIGHT VALIGN=TOP><B> " + "No. of Challans/Transfer Vouchers" + "</B></CENTER></TD>");
					toReturn.append("<TD WIDTH=125 ALIGN=RIGHT VALIGN=TOP><B> " + "Total Challan/Transfer Voucher Amount (Rs.)" + "</B></CENTER></TD>");
				}

				if (pReceipt.getForm_No().equals(FORM_24Q))
				{
					toReturn.append("<TD WIDTH=100 ALIGN=RIGHT VALIGN=TOP><B> " + "No. of Deductee Records" + "</B></TD>");

					toReturn.append("<TD WIDTH=125 ALIGN=RIGHT VALIGN=TOP><B> " + "Amount of Payment / Credit (Rs.)" + "</B></TD>");
					toReturn.append("<TD WIDTH=125 ALIGN=RIGHT VALIGN=TOP><B> " + "Total Income Tax Deducted at Source (Rs.)" + "</B></TD>");

					toReturn.append("<TD WIDTH=125 ALIGN=RIGHT VALIGN=TOP><B> " + "Total Tax Deposited as per Deductee Annexure (Rs.)" + "</B></TD>");
					toReturn.append("<TD WIDTH=75 ALIGN=RIGHT VALIGN=TOP><B> " + "No. of Salary Detail Records" + "</B></TD>");
					toReturn.append("<TD WIDTH=150 ALIGN=RIGHT VALIGN=TOP><B> " + "Batch Total of - Gross Total Income as per Salary Detail (Rs.)" + "</B></TD>");
					toReturn.append("<TD WIDTH=50 ALIGN=RIGHT VALIGN=TOP><B> " + "Upload Fee (Rs.)" + "</B></TD>");

				}
				else if (pReceipt.getForm_No().equals(FORM_27EQ))
				{
					toReturn.append("<TD WIDTH=100 ALIGN=RIGHT VALIGN=TOP><B> " + "No. of Party Records" + "</B></TD>");

					toReturn.append("<TD WIDTH=150 ALIGN=RIGHT VALIGN=TOP><B> " + "Amount Received / Debited (Rs.)" + "</B></TD>");
					toReturn.append("<TD WIDTH=150 ALIGN=RIGHT VALIGN=TOP><B> " + "Total Income Tax Collected at Source (Rs.)" + "</B></TD>");

					toReturn.append("<TD WIDTH=150 ALIGN=RIGHT VALIGN=TOP><B> " + "Total Tax Deposited as per Deductee Annexure (Rs.)" + "</B></TD>");

					toReturn.append("<TD WIDTH=125 ALIGN=RIGHT VALIGN=TOP><B> " + "Total Value of Purchase (Rs.)" + "</B></TD>");
					toReturn.append("<TD WIDTH=75 ALIGN=RIGHT VALIGN=TOP><B> " + "Upload Fee (Rs.)" + "</B></TD>");

				}
				else
				{ // means 26Q, 27Q
					toReturn.append("<TD WIDTH=100 ALIGN=RIGHT VALIGN=TOP><B> " + "No. of Deductee Records" + "</B></TD>");

					toReturn.append("<TD WIDTH=125 ALIGN=RIGHT VALIGN=TOP><B> " + "Amount of Payment / Credit (Rs.)" + "</B></TD>");
					toReturn.append("<TD WIDTH=200 ALIGN=RIGHT VALIGN=TOP><B> " + "Total Income Tax Deducted at Source (Rs.)" + "</B></TD>");

					toReturn.append("<TD WIDTH=225 ALIGN=RIGHT VALIGN=TOP><B> " + "Total Tax Deposited as per Deductee Annexure (Rs.)" + "</B></TD>");
					toReturn.append("<TD WIDTH=100 ALIGN=RIGHT VALIGN=TOP><B> " + "Upload Fee (Rs.)" + "</B></TD>");

				}

				toReturn.append("</TR>");
				toReturn.append("<TR>");
				// commented on 19-May-2005
				toReturn.append("<TD  ALIGN=RIGHT VALIGN=TOP>" + pReceipt.getNo_of_challans() + "</TD>");
				toReturn.append("<TD  ALIGN=RIGHT VALIGN=TOP>" + pReceipt.getTotal_Challan_Amount() + "</TD>");
				toReturn.append("<TD  ALIGN=RIGHT VALIGN=TOP>" + pReceipt.getNo_of_Deductee_Records() + "</TD>");
				toReturn.append("<TD  ALIGN=RIGHT VALIGN=TOP>" + pReceipt.getTotal_Amount_paid_credited_Org_Mode() + "</TD>");
				toReturn.append("<TD  ALIGN=RIGHT VALIGN=TOP>" + pReceipt.getTotal_Tax_Deducted_Org_Mode() + "</TD>");
				if (pReceipt.getForm_No().equals(FORM_24Q))
				{
					toReturn.append("<TD  ALIGN=RIGHT VALIGN=TOP>" + pReceipt.getTotal_Amount_deposited_Org_Mode() + "</TD>");
					toReturn.append("<TD  ALIGN=RIGHT VALIGN=TOP>" + pReceipt.getNo_of_Salary_Detail() + "</TD>");
					toReturn.append("<TD  ALIGN=RIGHT VALIGN=TOP>" + pReceipt.getTotal_Income_As_Per_SD() + "</TD>");
				}
				else if (pReceipt.getForm_No().equals(FORM_27EQ))
				{
					toReturn.append("<TD  ALIGN=RIGHT VALIGN=TOP>" + pReceipt.getTotal_Amount_deposited_Org_Mode() + "</TD>");
					toReturn.append("<TD  ALIGN=RIGHT VALIGN=TOP>" + pReceipt.getTotal_Value_of_Purchase() + "</TD>");
				}
				else
				{
					// means 26Q, 27Q
					toReturn.append("<TD  ALIGN=RIGHT VALIGN=TOP>" + pReceipt.getTotal_Amount_deposited_Org_Mode() + "</TD>");
				}
				toReturn.append("<TD  ALIGN=RIGHT VALIGN=TOP>" + pReceipt.getUpload_Fee() + "</TD>");
				toReturn.append("</TR>");

				//******************
				toReturn.append("</TABLE>");
				toReturn.append(
					"<TABLE BORDER=1 BORDERCOLOR=\"000000\" CELLSPACING=0 CELLPADDING=0 style='border-collapse:collapse; border:none;mso-border-alt:solid windowtext .5pt;mso-padding-alt:0in 5.4pt 0in 5.4pt'>");
				//******************

				toReturn.append("<TR>");
				toReturn.append("<TD WIDTH=1000>");
				toReturn.append("<BR>");
				toReturn.append("Deficiency (ies): ");
				toReturn.append("<BR>");
				toReturn.append("1) <B>" + pReceipt.getNo_of_PAN_Applied() + " case(s)</B> where deductee(s) has applied for <B>'Permanent Account Number'</B> <BR>");
				toReturn.append("2) <B>" + pReceipt.getNo_of_PAN_NotAvailabble() + " case(s)</B> where <B>'Permanent Account Number'</B> is not available for deductee(s) <BR>");
				toReturn.append("3) <B>" + pReceipt.getNo_of_PAN_Invalid() + " case(s)</B> where <B>'Permanent Account Number'</B> of deductee(s) is incorrect <BR>");
				toReturn.append("<BR>");
				toReturn.append("Please remove the deficiency(ies) within <B>7 days</B> by filling a revised return.");
				toReturn.append("<BR>");
				toReturn.append("<BR>");
				toReturn.append("<B> Last Deductee (LD) Detail Record in Challan(s) : </B>");
				if (!pReceipt.getNo_of_LD().equals(""))
				{
					StringTokenizer str = new StringTokenizer(pReceipt.getNo_of_LD(), "&");
					int no_of_token = str.countTokens();
					for (int i = 0; i < no_of_token; i++)
					{
						if (i < (no_of_token - 1))
							toReturn.append(str.nextToken() + ", ");
						else
							toReturn.append(str.nextToken());
					}
					toReturn.append(" (eg. LD1=2 means \"Last Deductee detail record no. of Challan 1 is 2\")");
					toReturn.append(" <BR>");
				}
				else
				{
					toReturn.append(" - <BR>");
				}

				if (pReceipt.getForm_No().equals(FORM_24Q))
				{
					if (!pReceipt.getNo_of_LS().equals(""))
					{
						toReturn.append("<B> Last Salary (LS) Details Record Number in Batch :  </B>  " + pReceipt.getNo_of_LS() + "<BR>");
					}
					else
					{
						toReturn.append("<B> Last Salary (LS) Details Record Number in Batch :  </B> - <BR>");
					}
				}

				toReturn.append(" </B><BR>");
				toReturn.append("Service Tax Registration No.:<B> AAACN2082NST001 - ST/MUM/DIV-III/BAS/2847 </B>");
				toReturn.append("<BR>");
				toReturn.append("<B>National Securities Depository Limited (e-TDS intermediary)</B>");
				toReturn.append("<BR>");
				if (isTanChange == true)
				{
					toReturn.append("<B>");
					toReturn.append("* TAN correction is subjected to approval from Income Tax Department");
					toReturn.append("<BR><BR>");
					toReturn.append("</B>");

				}
				toReturn.append("<B><I>This is a computer generated Provisional Receipt, hence signature not required.</I></B>");
				toReturn.append("</TD>");
				toReturn.append("</TR>");
				toReturn.append("</TABLE>");

			}
			toReturn.append("</TD>" + "</TR>" + "</TABLE>");
			toReturn.append("<BR><BR><BR><BR>");
			toReturn.append("<span ><br clear=all style='page-break-before:always'></span>");
			toReturn.append("</BODY>");
			toReturn.append("</HTML>");
			// FORMAT OF RECEIPT - END
			System.out.println("FileGenerator.java createProvisionalReceiptString() method is returning");
			return toReturn;
		}
		catch (Exception e)
		{
			System.err.println("Exception in FileGenerator.java createProvisionalReceiptString() method : " );e.printStackTrace();
			return null;
		}
	} // createProvisionalReceipt() over

	//Added by amit for FVU 4.1
	
	public boolean generateForm27A(String temppdfFileName,String pdfFileName , FileStatistics27A fstatistics27A,PDFFileStatisticData[] statisticData) throws BarcodeException, OutputException
	{
		
        FileGenerator flgObj = new FileGenerator();
        StringBuffer toReturn=new StringBuffer();
          DecimalFormatSymbols sf = new DecimalFormatSymbols(Locale.ENGLISH);
    	  DecimalFormat df  = new DecimalFormat("#.00",sf);
        int totNoOfDed =0;
        String totOfAmtPaid ="-";
        String totTaxDed ="-";
        String totTaxDep ="-";
        String finYear="";
        String assYear="";
    	String period="";
    	period=fstatistics27A.getPeriod();
    	finYear=fstatistics27A.getFinancial_Year();
    	String qNum=period.substring(1);
    	String firstYear=finYear.substring(2,4);
    	String lastYear=finYear.substring(4,6);
    	String startDate="";
    	String endDate="";
    	
    	if(qNum.equals("1"))
		{
			startDate="01/04/"+firstYear;
			endDate="30/06/"+firstYear;
		}
		else if(qNum.equals("2"))
		{
			startDate="01/07/"+firstYear;
			endDate="30/09/"+firstYear;
		}
		else if(qNum.equals("3"))
		{
			startDate="01/10/"+firstYear;
			endDate="31/12/"+firstYear;
		}
		else if(qNum.equals("4"))
		{
			startDate="01/01/"+lastYear;
			endDate="31/03/"+lastYear;
		}
		else
		{
			startDate="__/__/__";
			endDate="__/__/__";
		}
        
        //Added for barcode generation FVU 4.1
    	
      //  String sImagePath=pdfFileName.substring(0,pdfFileName.lastIndexOf('\\')+1);
       
        //added below line to for linux /window compatibility start  
		File pdfFileNamePath = new File(pdfFileName);	
		String sImagePath = pdfFileNamePath.getAbsolutePath().substring(0,pdfFileNamePath.getAbsolutePath().lastIndexOf(File.separator)+1);
		//added below line to for linux /window compatibility end
		   
        String ackNum=fstatistics27A.getTax_Ded_Acc_no()+fstatistics27A.getForm_No()+fstatistics27A.getPeriod()+fstatistics27A.getFinancial_Year();
        
        File ostrm=new File(sImagePath+"barcode.jpeg");
        
        Barcode barcode = null;
        // added by priyanka for barcode
        System.out.println(" BARCODE :- "+Hash.getBarcode());
        barcode=BarcodeFactory.createCode128(Hash.getBarcode());
        // end :: added by priyanka for barcode
        //barcode=BarcodeFactory.createCode128(ackNum);
        
		barcode.setBarWidth(1);
		barcode.setBarHeight(100);
		barcode.setDrawingText(false);
		BarcodeImageHandler.saveJPEG(barcode,ostrm);
		
		
        System.out.println("Inside generateForm27A");
		try
		{ 
			// FORMAT OF RECEIPT - START
		
			finYear=fstatistics27A.getFinancial_Year().substring(0,4)+"-"+fstatistics27A.getFinancial_Year().substring(4,6);
			assYear=fstatistics27A.getAssessment_Year().substring(0,4)+"-"+fstatistics27A.getAssessment_Year().substring(4,6);
			
			toReturn.append("<HTML><HEAD>");
			toReturn.append("<TITLE>FORM 27A</TITLE>");
			toReturn.append("<style type=text/css>");

			toReturn.append("td.col {");
			toReturn.append("	border: 1px solid black;");
			toReturn.append("}");
			
			toReturn.append("td.upper {");
			toReturn.append("text-transform:uppercase;");
			toReturn.append("}");

			toReturn.append("td.test {");
			toReturn.append("	border-bottom: 1px solid black;");
			toReturn.append("}");
			
			toReturn.append("td.padded {");
			toReturn.append("	padding:0px 50px 0px 50px;");
			toReturn.append("}");
			
			toReturn.append("table.tab {");
			toReturn.append("	");
			toReturn.append("    font-size: 40px;word-wrap: break-word;");
			toReturn.append("	}");

			toReturn.append("table.tab1 {");
			toReturn.append("	font-size:40px;word-wrap: break-word;");
			toReturn.append("	}");

			toReturn.append("</style>");
			toReturn.append("</HEAD>");
			toReturn.append("<BODY  style='width: 3080px;'>");
			
			toReturn.append("<table class=tab1  >");
			toReturn.append("	<tr>");
			toReturn.append("		<td width=250  align=left>File Hash</td>");
			// commented For FVU 5.2
			//toReturn.append("		<td width=515  align=left>"+fstatistics27A.getFilehash()+"</td>");
			//toReturn.append("		<td width=515  align=left><font size='20'>"+fstatistics27A.getFilehash().substring(0, 13)+"</font><font size='50'><strong>"+fstatistics27A.getFilehash().substring(13,20)+"</strong></font></td>");
			// Added For FVU 5.2
			toReturn.append("		<p><td width=515  align=left>"+fstatistics27A.getFilehash().substring(0, 13)+"<strong style='font-size: 155%;'>"+fstatistics27A.getFilehash().substring(13,20)+"</strong></p></td>");
			//toReturn.append("		<td width=515  align=left>"+fstatistics27A.getFilehash().substring(0, 13)+"<font size='350'><strong>"+fstatistics27A.getFilehash().substring(13,20)+"</strong></font></td>");
			toReturn.append("		<td width=1900  align=left></td>");
			toReturn.append("		<td width=100  align=center ><img src='barcode.jpeg'  style = 'width: 600px;'/></td>");
			toReturn.append("	</tr>");
			// Added by priyanka for barcode fvu4.9
			toReturn.append("	<tr>");
			toReturn.append("		<td width=250 align=left></td>");
			toReturn.append("		<td width=515 align=left></td>");
			toReturn.append("		<td width=1900 align=left></td>");
			// modified for FVU 5.2
			toReturn.append("		<td width=100 align=center style = 'padding-bottom:20px;'><font size='20'>"+Hash.getBarcode()+"</font><br></td>");
			toReturn.append("	</tr>");
			//End :: Added by priyanka for barcode fvu 4.9 
			toReturn.append("</table>");
			toReturn.append("<table bordercolor=black frame=box width=3080px><tr><td>"); // for border only
			toReturn.append("<table  width=3080px style='margin-top:20px;'  >");
			toReturn.append("<tr>");
			toReturn.append("<td >");
			toReturn.append("    <table border=0   class=tab1>");
			toReturn.append("    <tr><td width=3080 height=78 align=center  >");
			toReturn.append("        <strong><font size='10'>Form No. 27A</font></strong>");
			toReturn.append("        </td></tr>");
			toReturn.append("     <tr><td align=center>");
			//toReturn.append("          Form for furnishing information with the statement of deduction / collection of tax at source ( tick whichever is applicable ) filed on computer media for the period <strong><font size='20'>("+fstatistics27A.getPeriod()+") </font></strong> <br>(From "+startDate+" to "+endDate+" (dd/mm/yy)#)");
			
			// Added For FVU 5.2 
			toReturn.append("          Form for furnishing information with the statement of deduction / collection of tax at source ( tick whichever is applicable ) filed on computer media for the period "+fstatistics27A.getPeriod()+" <br>(From "+startDate+" to "+endDate+" (dd/mm/yy)#)");
			toReturn.append("          </td></tr>");
			toReturn.append("	  </table>");
			toReturn.append("</td></tr>");
			toReturn.append("	");
			toReturn.append("<tr><td width=3080px class=padded>");
			toReturn.append("	<table  class=tab style='margin-top:20px;'>");
			toReturn.append("	<tr>");
			toReturn.append("		<td align=left width=30>1</td>");
			toReturn.append("		<td width=550 align=left >(a)&nbsp; Tax Deduction Account No.</td>");
			toReturn.append("		<td class='col' width=849 align=center>"+fstatistics27A.getTax_Ded_Acc_no()+"</td>");
			toReturn.append("		<td width=200	></td>");
			toReturn.append("		<td width=550 align=left >(d)&nbsp; Financial Year</td>");
			toReturn.append("		<td class=col width=849 align=center>"+finYear+"</td>");
			toReturn.append("	</tr>");
			toReturn.append("	<tr>");
			toReturn.append("		<td height =12 colspan=6 ></td>");
			toReturn.append("	</tr>");
			toReturn.append("	<tr>");
			toReturn.append("		<td></td>");
			toReturn.append("		<td align=left>(b)&nbsp; Permanent Account No.</td>");
			toReturn.append("		<td class=col align=center>"+fstatistics27A.getPAN()+"</td>");
			toReturn.append("		<td></td>");
			toReturn.append("		<td align=left>(e)&nbsp; Assessment year</td>");
			toReturn.append("		<td class=col align=center>"+assYear+"</td>");
			toReturn.append("	</tr>");
			toReturn.append("	<tr>");
			toReturn.append("		<td height =12  colspan=6></td>");
			toReturn.append("	</tr>");
			toReturn.append("	<tr>");
			toReturn.append("		<td></td>");
			toReturn.append("		<td align=left>(c)&nbsp; Form No.</td>");
			toReturn.append("		<td class=col align=center>"+fstatistics27A.getForm_No()+"</td>");
			toReturn.append("		<td></td>");
			toReturn.append("		<td  align=left>(f)&nbsp; Previous receipt number</td>");
			toReturn.append("		<td class=col align=center>"+fstatistics27A.getPrevious_Prn()+"</td>");
			toReturn.append("	</tr>");
			toReturn.append("	<tr>");
			toReturn.append("		<td></td>");
			toReturn.append("		<td align=left></td>");
			toReturn.append("		<td class=col align=center></td>");
			toReturn.append("		<td></td>");
			toReturn.append("		<td  align=left>(In case return/statement has been filed earlier)</td>");
			toReturn.append("		<td></td>");
			toReturn.append("	</tr>");
			toReturn.append("	</table>");
			toReturn.append("</td></tr>");
			toReturn.append("	");
			toReturn.append("<tr><td class=padded>");
			toReturn.append("	<table  class=tab1>");
			toReturn.append("	<tr>");
			toReturn.append("		<td align=left width=30>2</td>");
			toReturn.append("		<td width=1600 align=left>Particulars of the deductor / collector</td>");
			toReturn.append("		<td  align=left>3 &nbsp;&nbsp;Name of the person responsible for deduction / collection of tax</td>");
			toReturn.append("	</tr>");
			toReturn.append("	</table>");
			toReturn.append("</td></tr>");
			toReturn.append("	");
			toReturn.append("<tr><td class=padded>");
			toReturn.append("	<table style='margin-top:20px;margin-bottom:20px;' cellspacing=0  >");
			toReturn.append("	<tr>");
			toReturn.append("	<td valign=top width=1605>");
			toReturn.append("		<table style='margin-left:40px;' class=tab bordercolor=black border='1px black solid' cellspacing=0>");
			toReturn.append("		<tr>");
			toReturn.append("			<td width=650 >(a) Name</td>");
			toReturn.append("			<td width=925 class='upper' align=center>"+fstatistics27A.getName_Deductor().toUpperCase()+"</td>");
			toReturn.append("		</tr>");
			toReturn.append("		<tr>");
			toReturn.append("			<td >(b) Type of deductor*</td>");
			toReturn.append("			<td class='upper' align=center>"+fstatistics27A.getType_Of_deductor().toUpperCase()+"</td>");
			toReturn.append("		</tr>");
			toReturn.append("		<tr>");
			toReturn.append("			<td  >(c) Branch / division (if any)</td>");
			toReturn.append("			<td class='upper' align=center>"+fstatistics27A.getBranch_Division().toUpperCase()+"</td>");
			toReturn.append("		</tr>");
			toReturn.append("		<tr>");
			toReturn.append("			<td >(d) Address</td>");
			toReturn.append("			<td class='upper' align=center>&nbsp;</td>");
			toReturn.append("		</tr>");
			toReturn.append("		<tr>");
			toReturn.append("			<td  >&nbsp;&nbsp;&nbsp;&nbsp; Flat No.</td>");
			toReturn.append("			<td class='upper' align=center>"+fstatistics27A.getFlat_No_Deductor().toUpperCase()+"</td>");
			toReturn.append("		</tr>");
			toReturn.append("		<tr>");
			toReturn.append("			<td  class=col>&nbsp;&nbsp;&nbsp;&nbsp; Name of the premises/building</td>");
			toReturn.append("			<td class='upper' align=center>"+ fstatistics27A.getName_Building_Deductor().toUpperCase()+ "</td>");
			toReturn.append("		</tr>");
			toReturn.append("		<tr>");
			toReturn.append("			<td  >&nbsp;&nbsp;&nbsp;&nbsp; Road / street / lane</td>");
			toReturn.append("			<td class='upper' align=center>"+ fstatistics27A.getRoad_Street_Deductor().toUpperCase()+ "</td>");
			toReturn.append("		</tr>");
			toReturn.append("		<tr>");
			toReturn.append("			<td  >&nbsp;&nbsp;&nbsp;&nbsp; Area / location</td>");
			toReturn.append("			<td class='upper' align=center>"+ fstatistics27A.getArea_loc_Deductor().toUpperCase()+ "</td>");
			toReturn.append("		</tr>");
			toReturn.append("		<tr>");
			toReturn.append("			<td  >&nbsp;&nbsp;&nbsp;&nbsp; Town / City / District</td>");
			toReturn.append("			<td class='upper' align=center>"+ fstatistics27A.getTown_City_Deductor().toUpperCase()+ "</td>");
			toReturn.append("		</tr>");
			toReturn.append("		<tr>");
			toReturn.append("			<td  >&nbsp;&nbsp;&nbsp;&nbsp; State</td>");
			toReturn.append("			<td class='upper' align=center>"+ fstatistics27A.getState_Deductor().toUpperCase()+ "</td>");
			toReturn.append("		</tr>");
			toReturn.append("		<tr>");
			toReturn.append("			<td  >&nbsp;&nbsp;&nbsp;&nbsp; Pin code</td>");
			toReturn.append("			<td class='upper' align=center>"+ fstatistics27A.getPin_Code_Deductor().toUpperCase()+ "</td>");
			toReturn.append("		</tr>");
			toReturn.append("		<tr>");
			toReturn.append("			<td  >&nbsp;&nbsp;&nbsp;&nbsp; Telephone No.</td>");
			toReturn.append("			<td class='upper' align=center>"+ fstatistics27A.getStd_Code_Deductor().toUpperCase()+"-"+fstatistics27A.getTelephone_Deductor().toUpperCase()+ "</td>");
			toReturn.append("		</tr>");
			toReturn.append("		<tr>");
			toReturn.append("			<td >&nbsp;&nbsp;&nbsp;&nbsp; E-mail</td>");
			toReturn.append("			<td class='upper' align=center>"+ fstatistics27A.getEmail_Deductor().toUpperCase()+ "</td>");
			toReturn.append("		</tr>");
			toReturn.append("		</table>");
			toReturn.append("	</td><td width=300 valign=top >");
			toReturn.append("	</td><td valign=top >");
			toReturn.append("		<table width=1350 style='margin-left:80px;' class=tab bordercolor=black border='1px black solid' cellspacing=0  >");
			toReturn.append("		<tr>");
			toReturn.append("			<td width=550 >(a)Name</td>");
			toReturn.append("			<td width=800 class='upper' align=center>"+ fstatistics27A.getName_Person().toUpperCase()+ "</td>");
			toReturn.append("		</tr>");
			toReturn.append("		<tr>");
			toReturn.append("			<td width=550 >(b)PAN</td>");
			toReturn.append("			<td width=800 class='upper' align=center>"+ fstatistics27A.getPanOfResponsiblePerson().toUpperCase()+ "</td>"); // Added for FVU 4.6
			toReturn.append("		</tr>");
			toReturn.append("		<tr>");
			toReturn.append("			<td>(c)Address</td>");
			toReturn.append("			<td class='upper'>&nbsp;</td>");
			toReturn.append("		</tr>");
			toReturn.append("		<tr>");
			toReturn.append("			<td>&nbsp; &nbsp; Flat No.</td>");
			toReturn.append("			<td class='upper' align=center>"+ fstatistics27A.getFlat_No_Person().toUpperCase()+ "</td>");
			toReturn.append("		</tr>");
			toReturn.append("		<tr>");
			toReturn.append("		<td>&nbsp; &nbsp; Name of the premises/building</td>");
			toReturn.append("		<td class='upper' align=center>"+ fstatistics27A.getName_Building_Person().toUpperCase()+ "</td>");
			toReturn.append("		</tr>");
			toReturn.append("		<tr>");
			toReturn.append("			<td>&nbsp;  &nbsp; Road / street / lane</td>");
			toReturn.append("			<td class='upper' align=center>"+ fstatistics27A.getRoad_Street_Person().toUpperCase()+ "</td>");
			toReturn.append("		</tr>");
			toReturn.append("		<tr>");
			toReturn.append("			<td>&nbsp; &nbsp; Area / location</td>");
			toReturn.append("			<td class='upper' align=center>"+ fstatistics27A.getArea_loc_Person().toUpperCase()+ "</td>");
			toReturn.append("		</tr>");
			toReturn.append("		<tr>");
			toReturn.append("			<td>&nbsp; &nbsp; Town / City / District</td>");
			toReturn.append("			<td class='upper' align=center>"+ fstatistics27A.getTown_City_Person().toUpperCase()+ "</td>");
			toReturn.append("		</tr>");
			toReturn.append("		<tr>");
			toReturn.append("			<td>&nbsp; &nbsp; State</td>");
			toReturn.append("			<td class='upper' align=center>"+ fstatistics27A.getState_Person().toUpperCase()+ "</td>");
			toReturn.append("		</tr>");
			toReturn.append("		<tr>");
			toReturn.append("			<td>&nbsp; &nbsp; Pin code</td>");
			toReturn.append("			<td class='upper' align=center>"+ fstatistics27A.getPin_Code_Person().toUpperCase()+ "</td>");
			toReturn.append("		</tr>");
			toReturn.append("		<tr>");
			toReturn.append("			<td>&nbsp; &nbsp; Telephone No.</td>");
			toReturn.append("			<td class='upper' align=center>"+ fstatistics27A.getStd_Code_Person().toUpperCase()+"-"+fstatistics27A.getTelephone_Person().toUpperCase()+ "</td>");
			toReturn.append("		</tr>");
			toReturn.append("		<tr>");
			toReturn.append("			<td>&nbsp; &nbsp; E-mail</td>");
			toReturn.append("			<td class='upper' align=center>"+ fstatistics27A.getEmail_Person().toUpperCase()+ "</td>");
			toReturn.append("		</tr>");
			toReturn.append("		</table>");
			toReturn.append("	</td></tr></table>");
			toReturn.append("</td></tr>");
			toReturn.append("	");
			toReturn.append("<tr><td class=padded>");
			toReturn.append("	<table class=tab1>");
			toReturn.append("	<tr>");
			toReturn.append("		<td width=30>4</td>");
			toReturn.append("		<td align=left>Control totals</td>");
			toReturn.append("	</tr>");
			toReturn.append("	</table>");
			toReturn.append("</td></tr>");
			toReturn.append("	");
			toReturn.append("<tr><td class=padded>");
			toReturn.append("	<table class=tab style='margin-top:20px;margin-left:40px;margin-bottom:20px;' cellspacing=0 bordercolor=black border='1px black solid' cellspacing=0>");
			toReturn.append("	<tr>");
			toReturn.append("		<td width=150 ><div align=center>Sr. No.<div></td>");
			toReturn.append("		<td width=500 ><div align=center>Return Type <br>(Regular &nbsp;/&nbsp; Correction type)</div></td>");
			toReturn.append("		<td width=400 ><div align=center>No. of deductee &nbsp;/&nbsp;party records<div></td>");
			toReturn.append("		<td width=300 ><div align=center>Amount paid <br>( <img src='rp.png' style='height:25px' width=15></img>)</div></td>");
			toReturn.append("		<td width=600 ><div align=center>Tax deducted&nbsp;/&nbsp;collected <br>( <img src='rp.png' style='height:25px' width=15></img>)</div> </td>");
			toReturn.append("		<td width=400 ><div align=center>Tax deposited<br>(Total challan amount) <br>( <img src='rp.png' style='height:25px' width=15></img>) </div></td>");
			toReturn.append("	</tr>");
							for(int i = 0;i<statisticData.length;i++)
							{
								
								
								toReturn.append("<tr>");
								toReturn.append("<td  align=center>"+(i+1)+"</td>");
								toReturn.append("<td  align=center>"+statisticData[i].getTransactionType().toUpperCase()+"</td>");
								if(statisticData[i].getNoOfDeductee()==0)
								{
									toReturn.append("<td  align=center>-</td>");
								}
								else
								{
									toReturn.append("<td  align=center>"+statisticData[i].getNoOfDeductee()+"</td>");
								}
								if(statisticData[i].getAmtPaid().equals(".00") || statisticData[i].getAmtPaid().equals("0.00"))
									toReturn.append("<td  align=center>-</td>");
								else
									toReturn.append("<td  align=center>"+statisticData[i].getAmtPaid()+"</td>");
								if(statisticData[i].getTaxDeducted().equals(".00") || statisticData[i].getTaxDeducted().equals("0.00"))
									toReturn.append("<td  align=center>-</td>");
								else
								toReturn.append("<td  align=center>"+statisticData[i].getTaxDeducted()+"</td>");
								if(statisticData[i].getTaxDeposited().equals(".00") || statisticData[i].getTaxDeposited().equals("0.00"))
									toReturn.append("<td  align=center>-</td>");
								else
								toReturn.append("<td  align=center>"+statisticData[i].getTaxDeposited()+"</td>");
								toReturn.append("</tr>");
								
									totNoOfDed+=statisticData[i].getNoOfDeductee();
								if(!statisticData[i].getAmtPaid().equals("-"))
									if(totOfAmtPaid.equals("-"))
										totOfAmtPaid=df.format(Double.parseDouble(statisticData[i].getAmtPaid()));
									else
										totOfAmtPaid=df.format(Double.parseDouble(totOfAmtPaid) + Double.parseDouble(statisticData[i].getAmtPaid()));
								if(!statisticData[i].getTaxDeducted().equals("-"))
									if(totTaxDed.equals("-"))
										totTaxDed=df.format(Double.parseDouble(statisticData[i].getTaxDeducted()));
									else
										totTaxDed=df.format(Double.parseDouble(totTaxDed) + Double.parseDouble(statisticData[i].getTaxDeducted()));
								if(!statisticData[i].getTaxDeposited().equals("-"))
									if(totTaxDep.equals("-"))
										totTaxDep=df.format(Double.parseDouble(statisticData[i].getTaxDeposited()));
									else
										totTaxDep=df.format(Double.parseDouble(totTaxDep) + Double.parseDouble(statisticData[i].getTaxDeposited()));
							}
			
			toReturn.append("	<tr>");
			toReturn.append("		<td  align=center>Total</td>");
			toReturn.append("		<td > &nbsp;</td>");
							if(totNoOfDed==0)
								toReturn.append("<td  align=center>-</td>");
							else
								toReturn.append("<td  align=center>"+totNoOfDed+"</td>");
							if(totOfAmtPaid.equals(".00") || totOfAmtPaid.equals("0.00"))
								toReturn.append("<td  align=center>-</td>");
							else
								toReturn.append("<td  align=center>"+totOfAmtPaid+"</td>");
							if(totTaxDed.equals(".00") || totTaxDed.equals("0.00"))
								toReturn.append("<td  align=center>-</td>");
							else
							toReturn.append("<td  align=center>"+totTaxDed+"</td>");
							if(totTaxDep.equals(".00") || totTaxDep.equals("0.00"))
								toReturn.append("<td  align=center>-</td>");
							else
							toReturn.append("	<td  align=center>"+totTaxDep+"</td>");
			toReturn.append("	</tr>");
			toReturn.append("	</table>");
			toReturn.append("</td></tr>");
			toReturn.append("	");
			toReturn.append("<tr><td class=padded>");
			toReturn.append("	<table class=tab>");
			toReturn.append("	<tr>");
			toReturn.append("		<td width=30>5</td>");
			toReturn.append("		<td width=1350 align=left>Total Number of Annexures enclosed</td>");
			toReturn.append("		<td width=650 class=col height=3> &nbsp;</td>");
			toReturn.append("	</tr>");
			toReturn.append("	</table>");
			toReturn.append("</td></tr>");
			toReturn.append("	");
			toReturn.append("<tr><td class=padded>");
			toReturn.append("	<table class=tab>");
			toReturn.append("	<tr>");
			toReturn.append("		<td width=30 >6</td>");
			toReturn.append("		<td width=1350 align=left>Other Information</td>");
			toReturn.append("		<td width=1500 class=col>&nbsp;</td>");
			toReturn.append("	</tr>");
			toReturn.append("	</table>");
			toReturn.append("</td></tr>");
			toReturn.append("	");
			toReturn.append("<tr><td class=padded>");
			toReturn.append("	<table class=tab width=3050 >");
			toReturn.append("	<tr>");
			toReturn.append("		<td height=50 colspan=3 align=center ><STRONG>VERIFICATION</STRONG></td>");
			toReturn.append("	</tr>");
			toReturn.append("	<tr>");
			toReturn.append("		<td width=60>I ,&nbsp;</td>");
			toReturn.append("		<td height=30 class='test upper' width=900 align=left>"+fstatistics27A.getVerification_Name().toUpperCase()+"</td>");
			toReturn.append("		<td width=1500>, hereby certify that all the particulars furnished above are correct and complete.</td>");
			toReturn.append("	</tr>");
			toReturn.append("	</table>");
			toReturn.append("	<br>");
			toReturn.append("	<table class=tab>");
			toReturn.append("	<tr>");
			toReturn.append("		<td height=30 width=50 align=left valign=bottom>Place:</td>");
			toReturn.append("		<td width=700  class=upper><div align=left valign=bottom>"+fstatistics27A.getVerification_Palce().toUpperCase()+" </div></td>");
			toReturn.append("		<td align=left valign=bottom>Signature of person responsible for deducting / collecting tax at source  </td>");
			toReturn.append("		<td width=1050 align=left class=test valign=bottom>&nbsp;</td>");
			toReturn.append("	</tr>");
			toReturn.append("	</table>");
			toReturn.append("	<table class=tab>");
			toReturn.append("	<tr>");
			toReturn.append("		<td height=30 width=50 align=left valign=bottom>Date:</td>");
			toReturn.append("		<td width=700><div align=left valign=bottom>"+fstatistics27A.getVerification_Date()+"</div></td>");
			toReturn.append("		<td align=left valign=bottom>&nbsp;Name and designation of person responsible for deducting / collecting tax at source  </td>");
			toReturn.append("		<td width=850 align=left class=test valign=bottom>"+fstatistics27A.getName_Person().toUpperCase() +",  "+ fstatistics27A.getResp_Prsn_Designation().toUpperCase()+"</td>");
			toReturn.append("	</tr>");
			toReturn.append("	<tr>");
			toReturn.append("		<td colspan=4 height=30 align=left>* Mention type of deductor - Government or Others</td>");
			toReturn.append("	</tr>");
			toReturn.append("	<tr>");
			toReturn.append("		<td colspan=4 height=30 align=left># dd/mm/yy :- date/month/year</td>");
			toReturn.append("</tr>");
			toReturn.append("	</table>");
			toReturn.append("</td></tr>");
			toReturn.append("</table>");
			toReturn.append("");
			toReturn.append("</td></tr></table>"); // outer border table
			
			toReturn.append("<br><table width=3080><tr><td><b><font size='12'> <div align=right>Generated by FVU Version "+ TDSFVUVersion +"</div></font></b></td></tr></table>");
			
			toReturn.append("</BODY>");
			toReturn.append("</HTML>");

			pdfFileName="27A_"+fstatistics27A.getTax_Ded_Acc_no()+"_"+fstatistics27A.getForm_No()+"_"+fstatistics27A.getPeriod()+"_"+fstatistics27A.getFinancial_Year()+".pdf";
			flgObj.writePdfFile(temppdfFileName,pdfFileName, toReturn);
			
			
			
			//shruti start watermark generation
			/*
			System.out.println("shruti : pdfFileName ::"+pdfFileName);
			System.out.println("shruti : temppdfFileName ::"+temppdfFileName);	
			int temp = temppdfFileName.lastIndexOf("\\");		
			String pdfpath = temppdfFileName.substring(0,temp);
			PDDocument realDoc = PDDocument.load(pdfpath+"\\"+pdfFileName); 
			HashMap<Integer, String> overlayGuide = new HashMap<Integer, String>();
            for(int s=0; s<realDoc.getPageCount(); s++){	
            	overlayGuide.put(s+1,"Watermarkimage.pdf");
                //watermark.pdf is the document which is a one page PDF with your watermark image in it. Notice here that you can skip pages from being watermarked.
            }
            Overlay overlay = new Overlay();
            overlay.setInputPDF(realDoc);
            overlay.setOutputFile(pdfpath+"\\"+pdfFileName);
            overlay.setOverlayPosition(Overlay.Position.BACKGROUND);
            overlay.overlay(overlayGuide,false);
            System.out.println("shruti : done ::"+pdfpath+"\\"+pdfFileName);
            */
            //shruti end
            
            
            
			return true;
		}
	
		catch (Exception e)
		{
			System.err.println("Exception in FileGenerator.java createProvisionalReceiptString() method : " );e.printStackTrace();
			return false;
		}
	
	
	}
	  
	//Ended By amit for createProvisionalReceiptForm27
	
	public FileStatistics getProvisionalDetail(String StringToParse, String Seperator)
	{
		FileStatistics fStatistics = new FileStatistics();
		System.out.println("FileGenerator.java ParseString() method is called ");

		StringTokenizer batch = new StringTokenizer(StringToParse, Seperator);
		int counter = 0;
		while (batch.hasMoreTokens())
		{
			String token = batch.nextToken();

			String name = token.substring(0, token.indexOf("="));
			String value = token.substring(token.indexOf("=") + 1, token.length());

			if (counter == 0) // BATCH No.
			{
				fStatistics.setBatch_No(value);
			}
			else if (counter == 1) //PANAPPLIED 
			{
				fStatistics.setNo_of_PAN_Applied(value);
			}
			else if (counter == 2) //PANINVALID
			{
				fStatistics.setNo_of_PAN_Invalid(value);
			}
			else if (counter == 3) //PANNOTAVNL
			{
				fStatistics.setNo_of_PAN_NotAvailabble(value);
			}
			else if (counter == 4) // LAST TAN
			{
				fStatistics.setLastTAN(value);
			}
			else if (counter == 5) // Total Amount Paid/Credited Original Mode  *** Added on 12 Sept 05 ****
			{
				fStatistics.setTotal_Amount_paid_credited_Org_Mode(value);
			}
			else if (counter == 6) // Total Amount Paid/Credited Update Mode
			{
				fStatistics.setTotal_Amount_paid_credited_Updt_Mode(value);
			}
			else if (counter == 7) // Total Amount Paid/Credited Add Mode
			{
				fStatistics.setTotal_Amount_paid_credited_Add_Mode(value);
			}
			else if (counter == 8) // Total Income Tax Deducted at Source Original Mode
			{
				fStatistics.setTotal_Tax_Deducted_Org_Mode(value);
			}
			else if (counter == 9) // Total Income Tax Deducted at Source Update Mode
			{
				fStatistics.setTotal_Tax_Deducted_Updt_Mode(value);
			}
			else if (counter == 10) // Total Income Tax Deducted at Source Add Mode
			{
				fStatistics.setTotal_Tax_Deducted_Add_Mode(value);
			}
			else if (counter == 11) // Total Income Tax Deducted at Source Delete Mode
			{
				fStatistics.setTotal_Tax_Deducted_Del_Mode(value);
			}
			else if (counter == 12) // Total of Deposited Amount Original Mode
			{
				fStatistics.setTotal_Amount_deposited_Org_Mode(value);
			}
			else if (counter == 13) // Total of Deposited Amount Update Mode
			{
				fStatistics.setTotal_Amount_deposited_Updt_Mode(value);
			}
			else if (counter == 14) // Total of Deposited Amount Add Mode
			{
				fStatistics.setTotal_Amount_deposited_Add_Mode(value);
			}
			else if (counter == 15) // Total of Deposited Amount Delete Mode *** Added on 12 Sept 05 ****
			{
				fStatistics.setTotal_Amount_deposited_Del_Mode(value);
			}
			else if (counter == 16) // Total Value of Purchase only for Form No. 27EQ
			{
				fStatistics.setTotal_Value_of_Purchase(value);
			}
			else if (counter == 17) //Total No of DD Record used for C5
			{
				fStatistics.setNo_DD_C5(value);
			}
			else if (counter == 18) //Total No of SD Record used for C5 
			{
				fStatistics.setNo_SD_C5(value);
			}
			else if (counter == 19) // LS
			{
				fStatistics.setNo_of_LS(value);
			}
			else // LD
				{
				fStatistics.setNo_of_LD(fStatistics.getNo_of_LD() + "&" + token);
			}
			counter++;
		} // while () inner While
		System.out.println("FileGenerator.java ParseString() method is returning ");
		return fStatistics;
	}

	public ArrayList parseString(String toParse, String Seperator)
	{
		ArrayList aList = new ArrayList();
		StringTokenizer parsed = new StringTokenizer(toParse, Seperator);
		while (parsed.hasMoreTokens())
		{
			aList.add(parsed.nextElement());
       
		}
		return aList;
	}
	/*
	 * Method to get Date in date Month Year format Eg. 4 April 2004
	 */
	private String setDateFormat(String dateString)
	{
		String month = dateString.substring(0, 2);
		String date = dateString.substring(3, 5);
		String year = dateString.substring(6, 10);
		switch (Integer.parseInt(month.trim()))
		{
			case 1 :
				month = "January";
				break;
			case 2 :
				month = "February";
				break;
			case 3 :
				month = "March";
				break;
			case 4 :
				month = "April";
				break;
			case 5 :
				month = "May";
				break;
			case 6 :
				month = "June";
				break;
			case 7 :
				month = "July";
				break;
			case 8 :
				month = "August";
				break;
			case 9 :
				month = "September";
				break;
			case 10 :
				month = "October";
				break;
			case 11 :
				month = "November";
				break;
			case 12 :
				month = "December";
				break;
		}
		dateString = date + " " + month + " " + year;
		return dateString;
	}
	/*
	 * Method to parse String to get Data for Return Statistics Report
	 */
	public FileStatistics getStatisticFileDetail(String StringToParse, String Seperator, FileStatistics fStatistics)
	{
		//System.out.println("FileGenerator.java getStatisticaFileDetail() method Called");
		StringTokenizer batch = new StringTokenizer(StringToParse, Seperator);
		int counter = 0;
		while (batch.hasMoreTokens())
		{
			String token = batch.nextToken();
			if (counter == 0) // No. of Challan
			{
				
				fStatistics.setNo_of_challans(token);
			}
			else if (counter == 1) //Form No.
			{
				
				fStatistics.setForm_No(token);
			}
			else if (counter == 2) //Transaction Type
			{
				
				fStatistics.setTransaction_Type(token);
			}
			else if (counter == 3) //TAN
			{
				
				fStatistics.setTAN(token);
			}
			else if (counter == 4) //Last TAN
			{
				
				fStatistics.setLastTAN(token);
			}
			else if (counter == 5) //PAN of TAN
			{
				
				fStatistics.setPAN_of_TAN(token);
			}
			else if (counter == 6) // Assmnt Year
			{
				
				fStatistics.setAssmnt_Year(token);
			}
			else if (counter == 7) // Financial Year
			{
				
				fStatistics.setFinancial_Year(token);
			}
			else if (counter == 8) // Quarter
			{
				
				fStatistics.setPeriodicity(token);
			}
			else if (counter == 9) // Name of TAN(Deductor/Collector/Employer)
			{
				
				fStatistics.setName_of_Deductor(token);
			}
			else if (counter == 10) // Total Amount of Challan
			{
				
				fStatistics.setTotal_Challan_Amount(token);
			}
			else if (counter == 11) // Total No. of Salary Detail Record.
			{
				
				fStatistics.setNo_of_Salary_Detail(token);
			}
			else if (counter == 12) // Total Of Amount as Per Salary Detail Salary
			{
				fStatistics.setTotal_Income_As_Per_SD(token);
			}
			//Added by sourabh
			else if (counter == 13)
			{
				fStatistics.setChallanCount(token);
			}
			else if (counter == 14)
			{
				fStatistics.setChallanAmount(token);
			}
			else if (counter == 15)
			{
				fStatistics.setTransferVoucherCount(token);
	
			}
			else if (counter == 16)
			{
				fStatistics.setTransferVoucherAmount(token);
			}
			else if (counter == 17)
			{
				fStatistics.setBookCashFlag(token);
			}
			else if (counter == 18)
			{
				fStatistics.setTotalCINMatchChallan(token);
			}
			else if (counter == 19)
			{
				fStatistics.setTotalCINNotMathcedChallan(token);
			}			
			else if (counter == 20) // total cin
			{
				fStatistics.setTotalCINChallan(token);
			}
						
			else if (counter == 21) // Total No. of deductee records
			{
				
				fStatistics.setNo_of_Deductee_Records(token);
			}
			else if (counter == 22) // Total No of Valid PAN
			{
				fStatistics.setNo_of_Valid_Pan(token);
			}
			else if(counter == 23) //No of DD With Remark C
			{
				fStatistics.settotalDDCntForHigherRate(token);
			}
			else // PAN Report
			{
				fStatistics.setPAN_Report_Table(fStatistics.getPAN_Report_Table() + token);
			}
			counter++;
		} // while () inner While
		//System.out.println("FileGenerator.java getStatisticaFileDetail() method is returning ");
		return fStatistics;
	}

//	 Added for change in statistics File Data ----- Nahush (21 Oct 08)
	
	public FileStatistics getStatisticSalDetail(String StringToParse, String Seperator, FileStatistics fStatistics)
	{
		//System.out.println("FileGenerator.java getStatisticSalDetail() method Called");
		StringTokenizer sal = new StringTokenizer(StringToParse, Seperator);
		int counter = 0;
		while (sal.hasMoreTokens())
		{
			String token = sal.nextToken();
			if (counter == 0) // No. of Valid Salary PAN
			{
				fStatistics.setNo_of_Sal_Valid_Pan(token);
			}
			else if (counter == 1) //No. of Applied Salary PAN
			{
				fStatistics.setNo_of_sal_PAN_Applied(token);
			}
			else if (counter == 2) //No. of Salary PAN no available
			{
				fStatistics.setNo_of_Sal_PAN_NotAvailable(token);
			}
			else if (counter == 3) //No. of Invalid Salary PAN
			{
				fStatistics.setNo_of_sal_PAN_Invalid(token);
			}
			else // PAN Report
				{
				fStatistics.setPAN_Report_Table(fStatistics.getPAN_Report_Table() + token);
			}
			counter++;
		} // while () inner While
		//System.out.println("FileGenerator.java getStatisticaFileDetail() method is returning ");
		return fStatistics;
	}
	
	
	private void createStatisticFile(FileStatistics fStatistics, String statisticFileName, boolean fileOpenFlag, boolean lastBatchOfFile, String fileName, String FVUVersion,boolean bsrPresent,String bsr,int bsrCount)
	{
		//M01_B
		
		/* Since the statistic report file is generated dynamically and the path for it is input by the
		 * the image of Rupee has to be created in the same path to get it displayed in the created 
		 * statistic report html file 
		 */
		//Creating the image of Rupee in the directory of statistic report
		try
		{
			//String sImagePath=statisticFileName.substring(0,statisticFileName.lastIndexOf('\\')+1);

			//added below line to for linux /window compatibility start  
			File statisticFileNamePath = new File(statisticFileName);	
			String sImagePath = statisticFileNamePath.getAbsolutePath().substring(0,statisticFileNamePath.getAbsolutePath().lastIndexOf(File.separator)+1);
			//added below line to for linux /window compatibility end
			
			InputStream is = ClassLoader.getSystemClassLoader().getResourceAsStream("images/rp.PNG");
			
			
			FileOutputStream fout = new FileOutputStream(sImagePath+"rp.png");
			
			while(is.available()!=0)
			{
				fout.write(is.read());
			}
			fout.flush();
			fout.close();
			is.close();

			
		}
		catch(Exception e)
		{
			System.err.println("Exception in FileGenerator.java  createStatisticFileString() method while creating the Rupee image : " ); e.printStackTrace();
			
		}
		//M01_E
		
		try
		{
			StringBuffer toReturn = new StringBuffer();
			FileGenerator flgObj = new FileGenerator();

			System.out.println("FileGenerator.java createStatisticFileString() method is called");
			boolean isTANChanged = false;
			boolean createTableForTANChange = false;

			// FORMAT OF FVU-STATISTICS Report- START
			toReturn.append("<HTML>");
			if (fStatistics.getForm_No().equals(FORM_27EQ))
			{
				toReturn.append("<HEAD> <TITLE> FVU -TCS STATEMENT STATISTICS REPORT</TITLE></HEAD>");
				toReturn.append("<BODY>");

				toReturn.append(
					"<TABLE BORDER=1 BORDERCOLOR=\"000000\" CELLSPACING=0 CELLPADDING=0 style='border-collapse: collapse; border: none; mso-border-alt: solid windowtext .5pt; mso-padding-alt: 0in 5.4pt 0in 5.4pt'>"
						+ "<TR>"
						+ "<TD>");
				toReturn.append(
					"<TABLE BORDER=0 BORDERCOLOR=\"000000\" CELLSPACING=0 CELLPADDING=0 style='border-collapse:collapse; border:none;mso-border-alt:solid windowtext .5pt;mso-padding-alt:0in 5.4pt 0in 5.4pt'>"
						+ "<TR>"
						+ "<TD><BR>");
				toReturn.append("<H3><CENTER> FVU -TCS STATEMENT STATISTICS REPORT - Batch Number " + fStatistics.getBatch_No() + "</CENTER></H3>");
			}
			else
			{
				toReturn.append("<HEAD> <TITLE> FVU -TDS STATEMENT STATISTICS REPORT </TITLE></HEAD>");
				toReturn.append("<BODY>");

				toReturn.append(
					"<TABLE BORDER=1 BORDERCOLOR=\"000000\" CELLSPACING=0 CELLPADDING=0 style='border-collapse: collapse; border: none; mso-border-alt: solid windowtext .5pt; mso-padding-alt: 0in 5.4pt 0in 5.4pt'>"
						+ "<TR>"
						+ "<TD>");
				toReturn.append(
					"<TABLE BORDER=0 BORDERCOLOR=\"000000\" CELLSPACING=0 CELLPADDING=0 style='border-collapse:collapse; border:none;mso-border-alt:solid windowtext .5pt;mso-padding-alt:0in 5.4pt 0in 5.4pt'>"
						+ "<TR>"
						+ "<TD><BR>");
				toReturn.append("<H3><CENTER> FVU -TDS STATEMENT STATISTICS REPORT - Batch Number " + fStatistics.getBatch_No() + "</CENTER></H3>");
				toReturn.append("</TD>" + "</TR>");
			}

			toReturn.append("<TR>");
			toReturn.append("<TD>");

			if (fStatistics.getUpload_Type().equals(UPLOADTYPE_REGULAR))
			{
				toReturn.append(
					"You are advised to verify the details of your TAN at Income Tax Departments web-site (www.incometaxindia.gov.in) before submission of the statement. "
						+ " If the data displayed is not updated then request for necessary changes by submitting Form for Changes or Corrections in TAN data for TAN allotted along with the statement. "
						+ " If such a request has already been filed, then please enclose a copy of acknowledgment of such request with the Form 27A.");
				toReturn.append(
					"<BR><BR>The details in the report are as per the statement prepared by you. In case of any discrepancy in the details, rectify the statement accordingly."
						+ " Thereafter, validate the rectified statement again through FVU.");
				toReturn.append("<BR><BR>The details provided in the physical Form 27A should match with the statistics report.");
				toReturn.append("<BR><BR>You can track the status of the challans as well as the statements furnished at www.tin-nsdl.com using TAN and Provisional Receipt Number.");
			}
			else
			{
				toReturn.append(
					"The details in the report are as per the statement prepared by you. In case of any discrepancy in the details, rectify the statement accordingly."
						+ "Thereafter, validate the rectified statement again through FVU.");
				toReturn.append("<BR><BR>The details provided in the physical Form 27A should match with the statistics report. This  report is required to be submitted along with Form 27A.");
				toReturn.append("<BR><BR>Furnish a copy of the Provisional Receipt issued for the corresponding regular statement along with Form 27A");
				toReturn.append("<BR><BR>You can track the status of the challans as well as the statements furnished at www.tin-nsdl.com using TAN and Provisional Receipt Number.");
			}

			toReturn.append("</TD>");
			toReturn.append("</TR>");
			toReturn.append("</TABLE>");
			toReturn.append("<BR><BR>");
			// First Table
			toReturn.append(
				"<TABLE BORDER=.5pt CELLSPACING=0 CELLPADDING=0 BORDERCOLOR=000000 style='border-collapse:collapse; border:none;mso-border-alt:solid windowtext .5pt;mso-padding-alt:0in 5.4pt 0in 5.4pt'>");
			toReturn.append("<TR>");
			if (fStatistics.getForm_No().equals(FORM_27EQ))
			{
				toReturn.append("<TD width=500 valign=top><B> " + "  Name of Collector	" + "</B></CENTER></TD>");
				if (!fStatistics.getTransaction_Type().equals(TRANSACTIONTYPE_CORRECTION_BATCH)
					|| (fStatistics.getTransaction_Type().equals(TRANSACTIONTYPE_CORRECTION_BATCH) && fStatistics.getTAN().equals(fStatistics.getLastTAN())))
				{
					toReturn.append("<TD width=250 valign=top><B> " + "  TAN of Collector " + "</B></CENTER></TD>");
				}
				else
				{
					createTableForTANChange = true;
				}
			}
			else
			{
				toReturn.append("<TD width=400 valign=top><B> " + "  Name of Deductor " + "</B></CENTER></TD>");
				if (!fStatistics.getTransaction_Type().equals(TRANSACTIONTYPE_CORRECTION_BATCH)
					|| (fStatistics.getTransaction_Type().equals(TRANSACTIONTYPE_CORRECTION_BATCH) && fStatistics.getTAN().equals(fStatistics.getLastTAN())))
				{
					toReturn.append("<TD width=200 valign=top><B> " + "  TAN of Deductor " + "</B></CENTER></TD>");
				}
				else
				{
					createTableForTANChange = true;
				}
			}
			toReturn.append("</TR>");
			toReturn.append("<TR>");
			toReturn.append("<TD  ALIGN=LEFT width=500> " + fStatistics.getName_of_Deductor() + "</TD>");
			if (!fStatistics.getTransaction_Type().equals(TRANSACTIONTYPE_CORRECTION_PAN))
			{
				if (!fStatistics.getTransaction_Type().equals(TRANSACTIONTYPE_CORRECTION_BATCH)
					|| (fStatistics.getTransaction_Type().equals(TRANSACTIONTYPE_CORRECTION_BATCH) && fStatistics.getTAN().equals(fStatistics.getLastTAN())))
				{
					toReturn.append("<TD  ALIGN=LEFT width=250> " + fStatistics.getTAN() + " </TD>");
				}
				else
				{
					/* In correction Files-C1 i.e Batch Correction if the TAN Changes than the TAN will be shown under "NEW TAN of Deductor" column of Statistic Report
					 * and OLD TAN will be shown under "TAN of Deductor" column. This is Because TAN Change is subjected to Approval from ITD. 
					 */
					isTANChanged = true;
				}
			}
			else
			{
				toReturn.append("<TD  ALIGN=LEFT width=250> " + fStatistics.getLastTAN() + " </TD>");
			}
			toReturn.append("</TR>");
			toReturn.append("</TABLE><P>");

			/*
			 * A New Table will be created for "TAN of Deductor" and "New TAN of Deductor" in Case of 
			 * TAN Change Request.
			 */
			if (createTableForTANChange)
			{
				toReturn.append(
					"<TABLE BORDER=.5pt CELLSPACING=0 CELLPADDING=0 BORDERCOLOR=000000 style='border-collapse:collapse; border:none;mso-border-alt:solid windowtext .5pt;mso-padding-alt:0in 5.4pt 0in 5.4pt'>");
				toReturn.append("<TR>");
				if (fStatistics.getForm_No().equals(FORM_27EQ))
				{
					toReturn.append("<TD width=250 valign=top><B> " + "  TAN of Collector " + "</B></CENTER></TD>");
					toReturn.append("<TD width=250 valign=top><B> " + "  New TAN of Collector* " + "</B></CENTER></TD>");
				}
				else
				{
					toReturn.append("<TD width=250 valign=top><B> " + "  TAN of Deductor " + "</B></CENTER></TD>");
					toReturn.append("<TD width=250 valign=top><B> " + "  New TAN of Deductor* " + "</B></CENTER></TD>");
				}
				toReturn.append("</TR>");

				toReturn.append("<TR>");
				toReturn.append("<TD  ALIGN=LEFT width=250> " + fStatistics.getLastTAN() + " </TD>");
				toReturn.append("<TD  ALIGN=LEFT width=250> " + fStatistics.getTAN() + " </TD>");
				toReturn.append("</TR>");
				toReturn.append("</TABLE><P>");

			}

			// 2 Table
			toReturn.append(
				"<TABLE BORDER=.5pt CELLSPACING=0 CELLPADDING=0 BORDERCOLOR=000000 style='border-collapse:collapse; border:none;mso-border-alt:solid windowtext .5pt;mso-padding-alt:0in 5.4pt 0in 5.4pt'>");
			toReturn.append("<TR>");
			if (fStatistics.getForm_No().equals(FORM_27EQ))
			{
				toReturn.append("<TD width=250 valign=top><B> " + "  PAN of Collector " + "</B></CENTER></TD>");
			}
			else
			{
				toReturn.append("<TD width=250 valign=top><B> " + "  PAN of Deductor " + "</B></CENTER></TD>");
			}
			toReturn.append("<TD valign=top><B> " + "  Form Number  " + "</B></CENTER></TD>");
			toReturn.append("<TD valign=top><B> " + "  Form Type  " + "</B></CENTER></TD>");
			toReturn.append("</TR>");
			toReturn.append("<TR>");
			toReturn.append("<TD  ALIGN=LEFT width=250> " + fStatistics.getPAN_of_TAN() + " </TD>");
			toReturn.append("<TD  ALIGN=LEFT width=250> " + fStatistics.getForm_No() + " </TD>");
			if (fStatistics.getForm_Type().equals(FILETYPE_SALARY_ELECTRONIC))
			{
				toReturn.append("<TD  ALIGN=LEFT width=250>" + "Salary (Electronic)" + "</TD>");
			}
			else if (fStatistics.getForm_Type().equals(FILETYPE_SALARY_DIGITAL))
			{
				toReturn.append("<TD  ALIGN=LEFT width=250>" + "Salary (Paper)" + "</TD>");
			}
			else if (fStatistics.getForm_Type().equals(FILETYPE_NONSALARY_ELECTRONIC))
			{
				toReturn.append("<TD  ALIGN=LEFT width=250>" + "Non-Salary (Electronic)" + "</TD>");
			}
			else if (fStatistics.getForm_Type().equals(FILETYPE_NONSALARY_DIGITAL))
			{
				toReturn.append("<TD  ALIGN=LEFT width=250>" + "Non-Salary (Paper)" + "</TD>");
			}
			else if (fStatistics.getForm_Type().equals(FILETYPE_TCS_ELECTRONIC))
			{
				toReturn.append("<TD  ALIGN=LEFT width=250>" + "TCS (Electronic)" + "</TD>");
			}
			else if (fStatistics.getForm_Type().equals(FILETYPE_TCS_DIGITAL))
			{
				toReturn.append("<TD  ALIGN=LEFT width=250>" + "TCS (Paper)" + "</TD>");
			}
			toReturn.append("</TR>");
			toReturn.append("</TABLE><P>");

			// 3 Table
			toReturn.append(
				"<TABLE BORDER=1 CELLSPACING=0 CELLPADDING=0 BORDERCOLOR=000000 style='border-collapse:collapse; border:none;mso-border-alt:solid windowtext .5pt;mso-padding-alt:0in 5.4pt 0in 5.4pt'>");
			toReturn.append("<TR>");
			toReturn.append("<TD valign=top><B> " + "  Assessment Year  " + "</B></CENTER></TD>");
			toReturn.append("<TD valign=top><B> " + "  Financial Year  " + "</B></CENTER></TD>");
			toReturn.append("<TD valign=top><B> " + "  Quarter  " + "</B></CENTER></TD>");
			toReturn.append("<TD valign=top><B> " + "  Upload Type  " + "</B></CENTER></TD>");
			toReturn.append("<TD valign=top><B> " + "  Type of Correction  " + "</B></CENTER></TD>");
			toReturn.append("</TR>");
			toReturn.append("<TR>");

			String assmntYear = fStatistics.getAssmnt_Year().substring(0, 4);
			String assmntYear2 = fStatistics.getAssmnt_Year().substring(4, 6);
			toReturn.append("<TD  ALIGN=LEFT width=150>" + assmntYear + "-" + assmntYear2 + " </TD>");
			String finanYear = fStatistics.getFinancial_Year().substring(0, 4);
			String finanYear2 = fStatistics.getFinancial_Year().substring(4, 6);
			toReturn.append("<TD  ALIGN=LEFT width=150>" + finanYear + "-" + finanYear2 + "</TD>");
			toReturn.append("<TD  ALIGN=LEFT width=150>" + fStatistics.getPeriodicity() + "</TD>");

			if (fStatistics.getUpload_Type().equals(UPLOADTYPE_REGULAR))
			{
				toReturn.append("<TD  ALIGN=LEFT width=160>" + "Regular" + "</TD>");
			}
			else
			{
				toReturn.append("<TD  ALIGN=LEFT width=160>" + "Correction" + "</TD>");
			}
			if (fStatistics.getUpload_Type().equals(UPLOADTYPE_REGULAR))
			{
				toReturn.append("<TD  ALIGN=LEFT width=300>" + "NA" + "</TD>");
			}
			else
			{
				//	FOR Transaction Type - START
				if (fStatistics.getTransaction_Type().equals(TRANSACTIONTYPE_CORRECTION_BATCH))
					toReturn.append("<TD  ALIGN=LEFT VALIGN=TOP width=300> " + TRANSACTIONTYPE_CORRECTION_BATCH_LABEL + "</TD>");
				else if (fStatistics.getTransaction_Type().equals(TRANSACTIONTYPE_ADDITION_CHALLAN))
					toReturn.append("<TD  ALIGN=LEFT VALIGN=TOP width=300> " + TRANSACTIONTYPE_ADDITION_CHALLAN_LABEL + "</TD>");
				else if (fStatistics.getTransaction_Type().equals(TRANSACTIONTYPE_CORRECTION_CHALLAN))
					toReturn.append("<TD  ALIGN=LEFT VALIGN=TOP width=300> " + TRANSACTIONTYPE_CORRECTION_CHALLAN_LABEL + "</TD>");
				else if (fStatistics.getTransaction_Type().equals(TRANSACTIONTYPE_CORRECTION_DEDUCTEE))
					toReturn.append("<TD  ALIGN=LEFT VALIGN=TOP width=300> " + TRANSACTIONTYPE_CORRECTION_DEDUCTEE_LABEL + "</TD>");
				else if (fStatistics.getTransaction_Type().equals(TRANSACTIONTYPE_CORRECTION_SALARY))
					toReturn.append("<TD  ALIGN=LEFT VALIGN=TOP width=300> " + TRANSACTIONTYPE_CORRECTION_SALARY_LABEL + "</TD>");
				else if (fStatistics.getTransaction_Type().equals(TRANSACTIONTYPE_CORRECTION_PAN))
					toReturn.append("<TD  ALIGN=LEFT VALIGN=TOP width=300> " + TRANSACTIONTYPE_CORRECTION_PAN_LABEL + "</TD>");
				else if (fStatistics.getTransaction_Type().equals(TRANSACTIONTYPE_CORRECTION_CANCELLATION))
					toReturn.append("<TD  ALIGN=LEFT VALIGN=TOP width=300> " + TRANSACTIONTYPE_CORRECTION_CANCELLATION_LABEL + "</TD>");
				else if (fStatistics.getTransaction_Type().equals(TRANSACTIONTYPE_CANCELLATION_BATCH))
					toReturn.append("<TD  ALIGN=LEFT VALIGN=TOP width=300> " + TRANSACTIONTYPE_CANCELLATION_BATCH_LABEL + "</TD>");
				else if (fStatistics.getTransaction_Type().equals(TRANSACTIONTYPE_REPLACE_SALARY))
					toReturn.append("<TD  ALIGN=LEFT VALIGN=TOP width=300> " + TRANSACTIONTYPE_REPLACE_SALARY_LABEL + "</TD>");
				else if (fStatistics.getTransaction_Type().equals(TRANSACTIONTYPE_CANCELLATION_BATCH_TFC))
					toReturn.append("<TD  ALIGN=LEFT VALIGN=TOP width=300> " + TRANSACTIONTYPE_CANCELLATION_BATCH_LABEL_TFC + "</TD>");

				// FOR Transaction Type - END
			}
			toReturn.append("</TR>");
			toReturn.append("</TABLE><BR>");

			// In C1 and Batch Cancellation these field will not be shown in Statistic Report
			if (!fStatistics.getTransaction_Type().equals(TRANSACTIONTYPE_CORRECTION_BATCH)
				&& !fStatistics.getTransaction_Type().equals(TRANSACTIONTYPE_CANCELLATION_BATCH)
				&& !fStatistics.getTransaction_Type().equals(TRANSACTIONTYPE_CANCELLATION_BATCH_TFC))
			{
				// 3 Table
				toReturn.append(
					"<TABLE BORDER=1 CELLSPACING=0 CELLPADDING=0 BORDERCOLOR=000000 style='border-collapse:collapse; border:none;mso-border-alt:solid windowtext .5pt;mso-padding-alt:0in 5.4pt 0in 5.4pt'>");
				toReturn.append("<TR>");
				if (!fStatistics.getTransaction_Type().equals(TRANSACTIONTYPE_CORRECTION_SALARY) && !fStatistics.getTransaction_Type().equals(TRANSACTIONTYPE_REPLACE_SALARY))
				{
					//Added by sourabh and edited
					if(fStatistics.getBookCashFlag().equals("C"))
					{
						//System.out.println(" CAME ONLY IN CHALLAN"+fStatistics.getBookCashFlag());
					
						toReturn.append("<TD valign=top width=200 style='text-align:left'><B> " + "No. of Challans" + "</B></TD>");
	
						if (!fStatistics.getTransaction_Type().equals(TRANSACTIONTYPE_CORRECTION_PAN))
						{
						   //M01_B The Rs letters are replaced by the image.
							//toReturn.append("<TD valign=top width=250 style='text-align:left'><B> " + "Total Challan Amount (Rs.)" + "</B></TD>");
							toReturn.append("<TD valign=top width=250 style='text-align:left'><B> " + "Total Challan Amount (<img src='rp.png'></img>)" + "</B></TD>");
							//M01_E
						}
					}
					else if (fStatistics.getBookCashFlag().equals("T"))
					{
						//System.out.println(" CAME ONLY IN TV"+fStatistics.getBookCashFlag());
						toReturn.append("<TD valign=top width=210 style='text-align:left'><B> " + "No. of Transfer Vouchers" + "</B></TD>");

						if (!fStatistics.getTransaction_Type().equals(TRANSACTIONTYPE_CORRECTION_PAN))
						{
							//M01_B The Rs letters are replaced by the image.
							toReturn.append("<TD valign=top width=250 style='text-align:left'><B> " + "Total Transfer Voucher Amount (<img src='rp.png'></img>)" + "</B></TD>");
							//M01_E
						}
					}
					else
					{
						//System.out.println(" CAME IN BOTH"+fStatistics.getBookCashFlag());
						toReturn.append("<TD valign=top width=200 style='text-align:left'><B> " + "No. of Challans" + "</B></TD>");

						if (!fStatistics.getTransaction_Type().equals(TRANSACTIONTYPE_CORRECTION_PAN))
						{
							//M01_B The Rs letters are replaced by the image.
							toReturn.append("<TD valign=top width=250 style='text-align:left'><B> " + "Total Challan Amount (<img src='rp.png'></img>)" + "</B></TD>");
							//M01_E
						}
						toReturn.append("<TD valign=top width=210 style='text-align:left'><B> " + "No. of Transfer Vouchers" + "</B></TD>");

						if (!fStatistics.getTransaction_Type().equals(TRANSACTIONTYPE_CORRECTION_PAN))
						{
							//M01_B The Rs letters are replaced by the image.
							toReturn.append("<TD valign=top width=255 style='text-align:left'><B> " + "Total Transfer Voucher Amount (<img src='rp.png'></img>)" + "</B></TD>");
							//M01_E
						}
					}
				}

				// In C2 and Challan Cancellation these field will not be shown in Statistic Report
				if (!fStatistics.getTransaction_Type().equals(TRANSACTIONTYPE_CORRECTION_CHALLAN)
					&& !fStatistics.getTransaction_Type().equals(TRANSACTIONTYPE_CORRECTION_CANCELLATION)
					&& !fStatistics.getTransaction_Type().equals(TRANSACTIONTYPE_CORRECTION_SALARY)
					&& !fStatistics.getTransaction_Type().equals(TRANSACTIONTYPE_REPLACE_SALARY))
				{
					if (fStatistics.getForm_No().equals(FORM_27EQ))
					{
						toReturn.append("<TD valign=top width=250 style='text-align:left'><B> " + "No. of Party Records" + "</B></TD>");
					}
					else
					{
						toReturn.append("<TD valign=top width=150 style='text-align:left'><B> " + "No. of Deductee Records" + "</B></TD>");
					}

					if (fStatistics.getForm_No().equals(FORM_27EQ))
					{
						//M01_B The Rs letters are replaced by the image.
						toReturn.append("<TD valign=top width=250 style='text-align:right'><B> " + "Total Value of Purchase (<img src='rp.png'></img>)" + "</B></TD>");
						//M01_E
					}
				}
//				Added by sourabh for removing data of SD from Q1,Q2,Q3
				if (fStatistics.getForm_No().equals(FORM_24Q)
					&& (fStatistics.getUpload_Type().equals(UPLOADTYPE_REGULAR)
						|| fStatistics.getTransaction_Type().equals(TRANSACTIONTYPE_CORRECTION_SALARY)
						|| fStatistics.getTransaction_Type().equals(TRANSACTIONTYPE_REPLACE_SALARY)
						|| fStatistics.getTransaction_Type().equals(TRANSACTIONTYPE_CORRECTION_PAN))&& fStatistics.getPeriodicity().equals("Q4"))
				{
					toReturn.append("<TD valign=top width=200 style='text-align:left'><B> " + "No. of Salary Detail Records" + "</B></TD>");
				}

				if (fStatistics.getForm_No().equals(FORM_24Q)
					&& (fStatistics.getUpload_Type().equals(UPLOADTYPE_REGULAR)
						|| fStatistics.getTransaction_Type().equals(TRANSACTIONTYPE_CORRECTION_SALARY)
						|| fStatistics.getTransaction_Type().equals(TRANSACTIONTYPE_REPLACE_SALARY))&&fStatistics.getPeriodicity().equals("Q4"))
				{
					//M01_B The Rs letters are replaced by the image.
					toReturn.append("<TD valign=top width=225 style='text-align:left'><B> " + "Batch Total of - Gross Total Income as per Salary Detail (<img src='rp.png'></img>)" + "</B></TD>");
					//M01_E
				}

				//************* Added By AMI For FVU 3.0 ****************
				// Form No. 27EQ added For FVU 3.0 new changes
				if((fStatistics.getTransaction_Type().equals(TRANSACTIONTYPE_CORRECTION_DEDUCTEE) || fStatistics.getTransaction_Type().equals(TRANSACTIONTYPE_ADDITION_CHALLAN) 
					|| fStatistics.getUpload_Type().equals(UPLOADTYPE_REGULAR)) &&  !fStatistics.getForm_No().equals(FORM_27EQ)) 
				{
					toReturn.append("<TD valign=top width=200 style='text-align:left'><B> " + "No. of Deductee Records where tax is deducted at Higher Rate" + "</B></TD>");
				}
				
				//End
				
				toReturn.append("</TR>");
				toReturn.append("<TR>");

				if (!fStatistics.getTransaction_Type().equals(TRANSACTIONTYPE_CORRECTION_SALARY) && !fStatistics.getTransaction_Type().equals(TRANSACTIONTYPE_REPLACE_SALARY))
				{
					//Added by sourabh
					if(fStatistics.getBookCashFlag().equals("C"))
					{
					
						//System.out.println(" CAME IN CV IN REPORT FOR "+fStatistics.getChallanCount());
						toReturn.append("<TD  ALIGN=RIGHT >" + fStatistics.getChallanCount() + "</TD>");
						//System.out.println(" CAME IN CV IN REPORT FOR:::::::::: "+fStatistics.getChallanCount());
						if (!fStatistics.getTransaction_Type().equals(TRANSACTIONTYPE_CORRECTION_PAN))
						{
							toReturn.append("<TD  ALIGN=RIGHT >" + fStatistics.getChallanAmount() + "</TD>");
						}
					}
					else if (fStatistics.getBookCashFlag().equals("T"))
					{
						toReturn.append("<TD  ALIGN=RIGHT >" + fStatistics.getTransferVoucherCount() + "</TD>");
	
						if (!fStatistics.getTransaction_Type().equals(TRANSACTIONTYPE_CORRECTION_PAN))
						{
							toReturn.append("<TD  ALIGN=RIGHT >" + fStatistics.getTransferVoucherAmount() + "</TD>");
						}
					}
					else
					{
						
						toReturn.append("<TD  ALIGN=RIGHT >" + fStatistics.getChallanCount() + "</TD>");

						if (!fStatistics.getTransaction_Type().equals(TRANSACTIONTYPE_CORRECTION_PAN))
						{
							toReturn.append("<TD  ALIGN=RIGHT >" + fStatistics.getChallanAmount() + "</TD>");
						}
						toReturn.append("<TD  ALIGN=RIGHT >" + fStatistics.getTransferVoucherCount() + "</TD>");
	
						if (!fStatistics.getTransaction_Type().equals(TRANSACTIONTYPE_CORRECTION_PAN))
						{
							toReturn.append("<TD  ALIGN=RIGHT >" + fStatistics.getTransferVoucherAmount() + "</TD>");
						}
					}
				}

				if (!fStatistics.getTransaction_Type().equals(TRANSACTIONTYPE_CORRECTION_CHALLAN)
					&& !fStatistics.getTransaction_Type().equals(TRANSACTIONTYPE_CORRECTION_CANCELLATION)
					&& !fStatistics.getTransaction_Type().equals(TRANSACTIONTYPE_CORRECTION_SALARY)
					&& !fStatistics.getTransaction_Type().equals(TRANSACTIONTYPE_REPLACE_SALARY))
				{
					toReturn.append("<TD  ALIGN=RIGHT >" + fStatistics.getNo_of_Deductee_Records() + "</TD>");

					if (fStatistics.getForm_No().equals(FORM_27EQ))
					{
						toReturn.append("<TD  ALIGN=RIGHT >" + fStatistics.getTotal_Value_of_Purchase() + "</TD>");
					}
				}
				//Added by sourabh for removing data of SD from Q1,Q2,Q3
				if (fStatistics.getForm_No().equals(FORM_24Q)
					&& (fStatistics.getUpload_Type().equals(UPLOADTYPE_REGULAR)
						|| fStatistics.getTransaction_Type().equals(TRANSACTIONTYPE_CORRECTION_SALARY)
						|| fStatistics.getTransaction_Type().equals(TRANSACTIONTYPE_REPLACE_SALARY)
						|| fStatistics.getTransaction_Type().equals(TRANSACTIONTYPE_CORRECTION_PAN))&&fStatistics.getPeriodicity().equals("Q4"))
				{
					toReturn.append("<TD  ALIGN=RIGHT >" + fStatistics.getNo_of_Salary_Detail() + "</TD>");
				}

				if (fStatistics.getForm_No().equals(FORM_24Q)
					&& (fStatistics.getUpload_Type().equals(UPLOADTYPE_REGULAR)
						|| fStatistics.getTransaction_Type().equals(TRANSACTIONTYPE_CORRECTION_SALARY)
						|| fStatistics.getTransaction_Type().equals(TRANSACTIONTYPE_REPLACE_SALARY))&&fStatistics.getPeriodicity().equals("Q4"))
				{
					toReturn.append("<TD  ALIGN=RIGHT >" + fStatistics.getTotal_Income_As_Per_SD() + "</TD>");
				}

//				System.out.println("getTotal_Income_As_Per_SD"+fStatistics.getTotal_Income_As_Per_SD().toString());
				
				//*************Added By AMI For FVU 3.0 ****************
				// Form No. 27EQ added For FVU 3.0 new changes
				if((fStatistics.getTransaction_Type().equals(TRANSACTIONTYPE_CORRECTION_DEDUCTEE) || fStatistics.getTransaction_Type().equals(TRANSACTIONTYPE_ADDITION_CHALLAN) 
						|| fStatistics.getUpload_Type().equals(UPLOADTYPE_REGULAR)) && !fStatistics.getForm_No().equals(FORM_27EQ))
				{
					toReturn.append("<TD  ALIGN=RIGHT >" + fStatistics.gettotalDDCntForHigherRate() + "</TD>");
				}
				
				//End
				
				toReturn.append("</TR>");
				toReturn.append("</TABLE><P>");

				// ************************************* //
				//*****Added by sourabh for a New Table for CIN Match table
				if((fStatistics.getTransaction_Type().equals(TRANSACTIONTYPE_CORRECTION_CHALLAN)||fStatistics.getTransaction_Type().equals(TRANSACTIONTYPE_CORRECTION_DEDUCTEE)||fStatistics.getTransaction_Type().equals(TRANSACTIONTYPE_ADDITION_CHALLAN)||fStatistics.getUpload_Type().equals(UPLOADTYPE_REGULAR))&&!fStatistics.getBookCashFlag().trim().equals("T"))
				{
				
					toReturn.append("<TABLE BORDER=1 CELLSPACING=0 CELLPADDING=0 BORDERCOLOR=000000 style='border-collapse:collapse; border:none;mso-border-alt:solid windowtext .5pt;mso-padding-alt:0in 5.4pt 0in 5.4pt'>");
					toReturn.append("<TR>");
					toReturn.append("<TD valign=top width=215 ><B> " + "No. of Challans (excluding nil) " + "</B></TD>");
					toReturn.append("<TD valign=top width=215 ><B> " + "No. of Unmatched challan " + "</B></TD>");
					toReturn.append("<TD valign=top width=215 ><B> " + "No. of Matched challan " + "</B></TD>");
					toReturn.append("</TR>");
					toReturn.append("<TD  ALIGN=RIGHT >" + fStatistics.getTotalCINChallan() + "</TD>");
					//changed as per new requirement by ganeshan
					
					if(FileStatistics.getCinUploadFlag() == 0&&Integer.parseInt(fStatistics.getTotalCINChallan())>0)
					toReturn.append("<TD  ALIGN=CENTER >" + "Challan not verified" + "</TD>");
					else
					toReturn.append("<TD  ALIGN=RIGHT >" + fStatistics.getTotalCINNotMathcedChallan() + "</TD>");
					
					if(FileStatistics.getCinUploadFlag() == 0&&Integer.parseInt(fStatistics.getTotalCINChallan())>0)
					toReturn.append("<TD  ALIGN=CENTER >" + "Challan not verified" + "</TD>");
					else
					toReturn.append("<TD  ALIGN=RIGHT >" + fStatistics.getTotalCINMatchChallan() + "</TD>");
					
					toReturn.append("</TABLE><P>");
				}
				//*****END by sourabh
				if (fStatistics.getUpload_Type().equals(UPLOADTYPE_REGULAR)
					|| fStatistics.getTransaction_Type().equals(TRANSACTIONTYPE_ADDITION_CHALLAN)
					|| fStatistics.getTransaction_Type().equals(TRANSACTIONTYPE_CORRECTION_DEDUCTEE))
				{
					//Table 5 STARTS		
					toReturn.append(
						"<TABLE BORDER=1 CELLSPACING=0 CELLPADDING=0 BORDERCOLOR=000000 style='border-collapse:collapse; border:none;mso-border-alt:solid windowtext .5pt;mso-padding-alt:0in 5.4pt 0in 5.4pt'>");
					toReturn.append("<TR>");

					if (fStatistics.getTransaction_Type().equals(TRANSACTIONTYPE_CORRECTION_DEDUCTEE))
					{
						toReturn.append("<TD valign=top width=215 ><B> " + "Particulars " + "</B></TD>");
					}

					if (fStatistics.getForm_No().equals(FORM_27EQ))
					{
						//M01_B The Rs letters are replaced by the image.
						toReturn.append("<TD valign=top width=215 style='text-align:left'><B> " + "Amount Received / Debited (<img src='rp.png'></img>)" + "</B></TD>");
						//M01_E
					}
					else
					{
						//M01_B The Rs letters are replaced by the image.
						toReturn.append("<TD valign=top width=215 style='text-align:left'><B> " + "Amount of Payment / Credit (<img src='rp.png'></img>)" + "</B></TD>");
						//M01_E
					}

					if (fStatistics.getForm_No().equals(FORM_27EQ))
					{
						//M01_B The Rs letters are replaced by the image.
						toReturn.append("<TD valign=top width=215 style='text-align:left'><B> " + "Total Income Tax Collected at Source (<img src='rp.png'></img>)" + "</B></TD>");
						//M01_E
					}
					else
						//M01_B The Rs letters are replaced by the image.
						toReturn.append("<TD valign=top width=215 style='text-align:left'><B> " + "Total Income Tax Deducted at Source (<img style='vertical-align: baseline' src='rp.png'></img>)" + "</B></TD>");
					   //M01_E
					if (fStatistics.getForm_No().equals(FORM_27EQ))
					{
						//M01_B The Rs letters are replaced by the image.
						toReturn.append("<TD valign=top width=215 style='text-align:left'><B> " + "Total Tax Deposited as per Party Annexure (<img src='rp.png'></img>)" + "</B></TD>");
						//M01_E
					}
					else
					{
						//M01_B The Rs letters are replaced by the image.
						toReturn.append("<TD valign=top width=215 style='text-align:left'><B> " + "Total Tax Deposited as per Deductee Annexure (<img src='rp.png'></img>)" + "</B></TD>");
						//M01_E
					}

					toReturn.append("</TR>");
					toReturn.append("<TR>");

					if (fStatistics.getUpload_Type().equals(UPLOADTYPE_REGULAR) || fStatistics.getTransaction_Type().equals(TRANSACTIONTYPE_ADDITION_CHALLAN))
					{
						toReturn.append("<TD  ALIGN=RIGHT >" + fStatistics.getTotal_Amount_paid_credited_Org_Mode() + "</TD>");
						toReturn.append("<TD  ALIGN=RIGHT >" + fStatistics.getTotal_Tax_Deducted_Org_Mode() + "</TD>");
						toReturn.append("<TD  ALIGN=RIGHT >" + fStatistics.getTotal_Amount_deposited_Org_Mode() + "</TD>");
					}
					else if (fStatistics.getTransaction_Type().equals(TRANSACTIONTYPE_CORRECTION_DEDUCTEE))
					{
						toReturn.append("<TR>");
						toReturn.append("<TD  ><B>" + "Added (a)" + "</B></TD>");
						toReturn.append("<TD  ALIGN=RIGHT >" + fStatistics.getTotal_Amount_paid_credited_Add_Mode() + "</TD>");
						toReturn.append("<TD  ALIGN=RIGHT >" + fStatistics.getTotal_Tax_Deducted_Add_Mode() + "</TD>");
						toReturn.append("<TD  ALIGN=RIGHT >" + fStatistics.getTotal_Amount_deposited_Add_Mode() + "</TD>");
						toReturn.append("</TR>");

						toReturn.append("<TR>");
						toReturn.append("<TD  ><B>" + "Updated (b)" + "</B></TD>");
						toReturn.append("<TD  ALIGN=RIGHT >" + fStatistics.getTotal_Amount_paid_credited_Updt_Mode() + "</TD>");
						toReturn.append("<TD  ALIGN=RIGHT >" + fStatistics.getTotal_Tax_Deducted_Updt_Mode() + "</TD>");
						toReturn.append("<TD  ALIGN=RIGHT >" + fStatistics.getTotal_Amount_deposited_Updt_Mode() + "</TD>");
						toReturn.append("</TR>");

						toReturn.append("<TR>");
						toReturn.append("<TD  ><B>" + "Deleted (c)" + "</B></TD>");
						toReturn.append("<TD  ALIGN=RIGHT >" + "NA" + "</TD>");
						toReturn.append("<TD  ALIGN=RIGHT >" + fStatistics.getTotal_Tax_Deducted_Del_Mode() + "</TD>");
						toReturn.append("<TD  ALIGN=RIGHT >" + fStatistics.getTotal_Amount_deposited_Del_Mode() + "</TD>");
						toReturn.append("</TR>");

						toReturn.append("<TR>");
						toReturn.append("<TD  ><B>" + "Total (a + b + c)" + "</B></TD>");

						// Total of Total_Amount_paid_credited of Mode Update and Add
						double val1 = 0.00;
						double val2 = 0.00;
						double val3 = 0.00;
						String outputValue = null;
						if (!fStatistics.getTotal_Amount_paid_credited_Add_Mode().equals("-"))
						{
							val1 = Double.parseDouble(fStatistics.getTotal_Amount_paid_credited_Add_Mode().trim());
						}

						if (!fStatistics.getTotal_Amount_paid_credited_Updt_Mode().equals("-"))
						{
							val2 = Double.parseDouble(fStatistics.getTotal_Amount_paid_credited_Updt_Mode().trim());
						}

						val3 = val1 + val2;
						val3 = Math.round((double) (val3 * 100)) / 100.0;
						FieldValidation fvObj = new FieldValidation();
						outputValue = fvObj.changeNumberFormat(val3);
						toReturn.append("<TD  ALIGN=RIGHT >" + outputValue + "</TD>");
						// Total of Total_Amount_paid_credited of Mode Update and Add

						// Total of Total_Tax_Deducted of Mode Update, Add and Delete
						val1 = 0.00;
						val2 = 0.00;
						val3 = 0.00;
						double val4 = 0.00;

						if (!fStatistics.getTotal_Tax_Deducted_Add_Mode().equals("-"))
						{
							val1 = Double.parseDouble(fStatistics.getTotal_Tax_Deducted_Add_Mode().trim());
						}

						if (!fStatistics.getTotal_Tax_Deducted_Updt_Mode().equals("-"))
						{
							val2 = Double.parseDouble(fStatistics.getTotal_Tax_Deducted_Updt_Mode().trim());
						}

						if (!fStatistics.getTotal_Tax_Deducted_Del_Mode().equals("-"))
						{
							val3 = Double.parseDouble(fStatistics.getTotal_Tax_Deducted_Del_Mode().trim());
						}

						val4 = val1 + val2 + val3;
						val4 = Math.round((double) (val4 * 100)) / 100.0;
						outputValue = null;
						outputValue = fvObj.changeNumberFormat(val4);
						toReturn.append("<TD  ALIGN=RIGHT >" + outputValue + "</TD>");
						// Total of Total_Tax_Deducted of Mode Update, Add and Delete

						// Total of Total_Amount_deposited of Mode Update, Add and Delete
						val1 = 0.00;
						val2 = 0.00;
						val3 = 0.00;
						val4 = 0.00;
						if (!fStatistics.getTotal_Amount_deposited_Add_Mode().equals("-"))
						{
							val1 = Double.parseDouble(fStatistics.getTotal_Amount_deposited_Add_Mode().trim());
						}

						if (!fStatistics.getTotal_Amount_deposited_Updt_Mode().equals("-"))
						{
							val2 = Double.parseDouble(fStatistics.getTotal_Amount_deposited_Updt_Mode().trim());
						}

						if (!fStatistics.getTotal_Amount_deposited_Del_Mode().equals("-"))
						{
							val3 = Double.parseDouble(fStatistics.getTotal_Amount_deposited_Del_Mode().trim());
						}

						val4 = val1 + val2 + val3;
						val4 = Math.round((double) (val4 * 100)) / 100.0;
						outputValue = null;
						outputValue = fvObj.changeNumberFormat(val4);

						toReturn.append("<TD  ALIGN=RIGHT >" + outputValue + "</TD>");
						// Total of Total_Amount_deposited of Mode Update, Add and Delete

						toReturn.append("</TR>");
					}

					toReturn.append("</TR>");
					toReturn.append("</TABLE>");
					// Table 5 ENDS
				}

				if (fStatistics.getUpload_Type().equals(UPLOADTYPE_REGULAR)
					|| fStatistics.getTransaction_Type().equals(TRANSACTIONTYPE_ADDITION_CHALLAN)
					|| fStatistics.getTransaction_Type().equals(TRANSACTIONTYPE_CORRECTION_DEDUCTEE)
					|| fStatistics.getTransaction_Type().equals(TRANSACTIONTYPE_CORRECTION_SALARY)
					|| fStatistics.getTransaction_Type().equals(TRANSACTIONTYPE_REPLACE_SALARY))
				{
					if (fStatistics.getForm_No().equals(FORM_27EQ))
					{
						toReturn.append("<H4> Party PAN Details </H4>");
						toReturn.append(
						"<TABLE BORDER=1 CELLSPACING=0 CELLPADDING=0 BORDERCOLOR=000000 style='border-collapse:collapse; border:none;mso-border-alt:solid windowtext .5pt;mso-padding-alt:0in 5.4pt 0in 5.4pt'>");
					toReturn.append("<TR>");
					toReturn.append("<TD valign=top style='text-align:left'><B> " + "No. of Valid PAN " + "</B></CENTER></TD>");
					toReturn.append("<TD valign=top style='text-align:left'><B> " + "No. of PAN Applied " + "</B></CENTER></TD>");
					toReturn.append("<TD valign=top style='text-align:left'><B> " + "No. of PAN Not Available " + "</B></CENTER></TD>");
					toReturn.append("<TD valign=top style='text-align:left'><B> " + "No. of Structurally Invalid PAN " + "</B></CENTER></TD>");
					toReturn.append("</TR>");
					// Deductee Records are provided only in Regular File and C3

					toReturn.append("<TR>");
					toReturn.append("<TD  ALIGN=RIGHT width=195>" + fStatistics.getNo_of_Valid_Pan() + " </TD>");

					if (!fStatistics.getNo_of_PAN_Applied().equals("-"))
					{
						toReturn.append("<TD  ALIGN=RIGHT width=189>" + fStatistics.getNo_of_PAN_Applied() + " </TD>");
					}
					else
					{
						toReturn.append("<TD  ALIGN=RIGHT width=189>" + "-" + " </TD>");
					}

					if (!fStatistics.getNo_of_PAN_NotAvailabble().equals("-"))
					{
						toReturn.append("<TD  ALIGN=RIGHT width=189>" + fStatistics.getNo_of_PAN_NotAvailabble() + " </TD>");
					}
					else
					{
						toReturn.append("<TD  ALIGN=RIGHT width=189>" + "-" + " </TD>");
					}
					if (!fStatistics.getNo_of_PAN_Invalid().equals("-"))
					{
						toReturn.append("<TD  ALIGN=RIGHT width=189>" + fStatistics.getNo_of_PAN_Invalid() + " </TD>");
					}
					else
					{
						toReturn.append("<TD  ALIGN=RIGHT width=189>" + "-" + " </TD>");
					}

					toReturn.append("</TR>");
										
					toReturn.append("</TABLE>");
					
					}
					else if(fStatistics.getForm_No().equals(FORM_24Q) && fStatistics.getPeriodicity().equals("Q4"))
					{
	                    if (fStatistics.getTransaction_Type().equals(TRANSACTIONTYPE_CORRECTION_SALARY))
	                    {
							toReturn.append("<H4> Salary PAN Details (Annexure II) </H4>");
							toReturn.append(
							"<TABLE BORDER=1 CELLSPACING=0 CELLPADDING=0 BORDERCOLOR=000000 style='border-collapse:collapse; border:none;mso-border-alt:solid windowtext .5pt;mso-padding-alt:0in 5.4pt 0in 5.4pt'>");
						    toReturn.append("<TR>");
						    toReturn.append("<TD valign=top style='text-align:left'><B> " + "No. of Valid PAN " + "</B></CENTER></TD>");
						    toReturn.append("<TD valign=top style='text-align:left'><B> " + "No. of PAN Applied (PANAPPLIED)" + "</B></CENTER></TD>");
						    toReturn.append("<TD valign=top style='text-align:left'><B> " + "No. of PAN Not Available (PANNOTAVBL)" + "</B></CENTER></TD>");
						    toReturn.append("<TD valign=top style='text-align:left'><B> " + "No. of Structurally Invalid PAN (PANINVALID)" + "</B></CENTER></TD>");
						    toReturn.append("</TR>");
						    // Deductee Records are provided only in Regular File and C3

						    toReturn.append("<TR>");
						    toReturn.append("<TD  ALIGN=RIGHT width=195>" + fStatistics.getNo_of_Sal_Valid_Pan() + " </TD>");

	       					if (!fStatistics.getNo_of_PAN_Applied().equals("-"))
			    			{
				    			toReturn.append("<TD  ALIGN=RIGHT width=189>" + fStatistics.getNo_of_sal_PAN_Applied() + " </TD>");
					    	}
						    else
						    {
							    toReturn.append("<TD  ALIGN=RIGHT width=189>" + "-" + " </TD>");
						    }

					    	if (!fStatistics.getNo_of_PAN_NotAvailabble().equals("-"))
						    {
							    toReturn.append("<TD  ALIGN=RIGHT width=189>" + fStatistics.getNo_of_sal_PAN_NotAvailabble() + " </TD>");
						    }
							else
							{
								toReturn.append("<TD  ALIGN=RIGHT width=189>" + "-" + " </TD>");
							}
							if (!fStatistics.getNo_of_PAN_Invalid().equals("-"))
							{
								toReturn.append("<TD  ALIGN=RIGHT width=189>" + fStatistics.getNo_of_sal_PAN_Invalid() + " </TD>");
							}
							else
							{
								toReturn.append("<TD  ALIGN=RIGHT width=189>" + "-" + " </TD>");
							}
		
							toReturn.append("</TR>");
												
							toReturn.append("</TABLE>");

	                    }
						
	                    else if (fStatistics.getTransaction_Type().equals(TRANSACTIONTYPE_ADDITION_CHALLAN) || fStatistics.getTransaction_Type().equals(TRANSACTIONTYPE_CORRECTION_DEDUCTEE))
	                    {
		                    toReturn.append("<H4> Deductee PAN Details (Annexure I) </H4>");
							// 6 Table
							toReturn.append(
								"<TABLE BORDER=1 CELLSPACING=0 CELLPADDING=0 BORDERCOLOR=000000 style='border-collapse:collapse; border:none;mso-border-alt:solid windowtext .5pt;mso-padding-alt:0in 5.4pt 0in 5.4pt'>");
							toReturn.append("<TR>");
							toReturn.append("<TD valign=top style='text-align:left'><B> " + "No. of Valid PAN " + "</B></CENTER></TD>");
							toReturn.append("<TD valign=top style='text-align:left'><B> " + "No. of PAN Applied (PANAPPLIED)" + "</B></CENTER></TD>");
							toReturn.append("<TD valign=top style='text-align:left'><B> " + "No. of PAN Not Available (PANNOTAVBL)" + "</B></CENTER></TD>");
							toReturn.append("<TD valign=top style='text-align:left'><B> " + "No. of Structurally Invalid PAN (PANINVALID)" + "</B></CENTER></TD>");
							toReturn.append("</TR>");
							// Deductee Records are provided only in Regular File and C3

							toReturn.append("<TR>");
							toReturn.append("<TD  ALIGN=RIGHT width=195>" + fStatistics.getNo_of_Valid_Pan() + " </TD>");

							if (!fStatistics.getNo_of_PAN_Applied().equals("-"))
							{
								toReturn.append("<TD  ALIGN=RIGHT width=189>" + fStatistics.getNo_of_PAN_Applied() + " </TD>");
							}
							else
							{
								toReturn.append("<TD  ALIGN=RIGHT width=189>" + "-" + " </TD>");
							}

							if (!fStatistics.getNo_of_PAN_NotAvailabble().equals("-"))
							{
								toReturn.append("<TD  ALIGN=RIGHT width=189>" + fStatistics.getNo_of_PAN_NotAvailabble() + " </TD>");
							}
							else
							{
								toReturn.append("<TD  ALIGN=RIGHT width=189>" + "-" + " </TD>");
							}
							if (!fStatistics.getNo_of_PAN_Invalid().equals("-"))
							{
								toReturn.append("<TD  ALIGN=RIGHT width=189>" + fStatistics.getNo_of_PAN_Invalid() + " </TD>");
							}
							else
							{
								toReturn.append("<TD  ALIGN=RIGHT width=189>" + "-" + " </TD>");
							}

							toReturn.append("</TR>");
												
							toReturn.append("</TABLE> <P>");

	                    }
	                    
	                    else
	                    {
	                    toReturn.append("<H4> Deductee PAN Details (Annexure I) </H4>");
						// 6 Table
						toReturn.append(
							"<TABLE BORDER=1 CELLSPACING=0 CELLPADDING=0 BORDERCOLOR=000000 style='border-collapse:collapse; border:none;mso-border-alt:solid windowtext .5pt;mso-padding-alt:0in 5.4pt 0in 5.4pt'>");
						toReturn.append("<TR>");
						toReturn.append("<TD valign=top style='text-align:left'><B> " + "No. of Valid PAN " + "</B></CENTER></TD>");
						toReturn.append("<TD valign=top style='text-align:left'><B> " + "No. of PAN Applied (PANAPPLIED)" + "</B></CENTER></TD>");
						toReturn.append("<TD valign=top style='text-align:left'><B> " + "No. of PAN Not Available (PANNOTAVBL)" + "</B></CENTER></TD>");
						toReturn.append("<TD valign=top style='text-align:left'><B> " + "No. of Structurally Invalid PAN (PANINVALID)" + "</B></CENTER></TD>");
						toReturn.append("</TR>");
						// Deductee Records are provided only in Regular File and C3

						toReturn.append("<TR>");
						toReturn.append("<TD  ALIGN=RIGHT width=195>" + fStatistics.getNo_of_Valid_Pan() + " </TD>");

						if (!fStatistics.getNo_of_PAN_Applied().equals("-"))
						{
							toReturn.append("<TD  ALIGN=RIGHT width=189>" + fStatistics.getNo_of_PAN_Applied() + " </TD>");
						}
						else
						{
							toReturn.append("<TD  ALIGN=RIGHT width=189>" + "-" + " </TD>");
						}

						if (!fStatistics.getNo_of_PAN_NotAvailabble().equals("-"))
						{
							toReturn.append("<TD  ALIGN=RIGHT width=189>" + fStatistics.getNo_of_PAN_NotAvailabble() + " </TD>");
						}
						else
						{
							toReturn.append("<TD  ALIGN=RIGHT width=189>" + "-" + " </TD>");
						}
						if (!fStatistics.getNo_of_PAN_Invalid().equals("-"))
						{
							toReturn.append("<TD  ALIGN=RIGHT width=189>" + fStatistics.getNo_of_PAN_Invalid() + " </TD>");
						}
						else
						{
							toReturn.append("<TD  ALIGN=RIGHT width=189>" + "-" + " </TD>");
						}

						toReturn.append("</TR>");
											
						toReturn.append("</TABLE><P>");
	
						
						toReturn.append("<H4> Salary PAN Details (Annexure II) </H4>");
						toReturn.append(
						"<TABLE BORDER=1 CELLSPACING=0 CELLPADDING=0 BORDERCOLOR=000000 style='border-collapse:collapse; border:none;mso-border-alt:solid windowtext .5pt;mso-padding-alt:0in 5.4pt 0in 5.4pt'>");
					    toReturn.append("<TR>");
					    toReturn.append("<TD valign=top style='text-align:left'><B> " + "No. of Valid PAN " + "</B></CENTER></TD>");
					    toReturn.append("<TD valign=top style='text-align:left'><B> " + "No. of PAN Applied (PANAPPLIED)" + "</B></CENTER></TD>");
					    toReturn.append("<TD valign=top style='text-align:left'><B> " + "No. of PAN Not Available (PANNOTAVBL)" + "</B></CENTER></TD>");
					    toReturn.append("<TD valign=top style='text-align:left'><B> " + "No. of Structurally Invalid PAN (PANINVALID)" + "</B></CENTER></TD>");
					    toReturn.append("</TR>");
					    // Deductee Records are provided only in Regular File and C3

					    toReturn.append("<TR>");
					    toReturn.append("<TD  ALIGN=RIGHT width=195>" + fStatistics.getNo_of_Sal_Valid_Pan() + " </TD>");

       					if (!fStatistics.getNo_of_PAN_Applied().equals("-"))
		    			{
			    			toReturn.append("<TD  ALIGN=RIGHT width=189>" + fStatistics.getNo_of_sal_PAN_Applied() + " </TD>");
				    	}
					    else
					    {
						    toReturn.append("<TD  ALIGN=RIGHT width=189>" + "-" + " </TD>");
					    }

				    	if (!fStatistics.getNo_of_PAN_NotAvailabble().equals("-"))
					    {
						    toReturn.append("<TD  ALIGN=RIGHT width=189>" + fStatistics.getNo_of_sal_PAN_NotAvailabble() + " </TD>");
					    }
						else
						{
							toReturn.append("<TD  ALIGN=RIGHT width=189>" + "-" + " </TD>");
						}
						if (!fStatistics.getNo_of_PAN_Invalid().equals("-"))
						{
							toReturn.append("<TD  ALIGN=RIGHT width=189>" + fStatistics.getNo_of_sal_PAN_Invalid() + " </TD>");
						}
						else
						{
							toReturn.append("<TD  ALIGN=RIGHT width=189>" + "-" + " </TD>");
						}
	
						toReturn.append("</TR>");
											
						toReturn.append("</TABLE> <P>");
	                    }	
					}
					
				
					
					else
					{
						toReturn.append("<H4> Deductee PAN Details (Annexure I) </H4>");
					// 6 Table
					toReturn.append(
						"<TABLE BORDER=1 CELLSPACING=0 CELLPADDING=0 BORDERCOLOR=000000 style='border-collapse:collapse; border:none;mso-border-alt:solid windowtext .5pt;mso-padding-alt:0in 5.4pt 0in 5.4pt'>");
					toReturn.append("<TR>");
					toReturn.append("<TD valign=top style='text-align:left'><B> " + "No. of Valid PAN " + "</B></CENTER></TD>");
					toReturn.append("<TD valign=top style='text-align:left'><B> " + "No. of PAN Applied (PANAPPLIED)" + "</B></CENTER></TD>");
					toReturn.append("<TD valign=top style='text-align:left'><B> " + "No. of PAN Not Available (PANNOTAVBL)" + "</B></CENTER></TD>");
					toReturn.append("<TD valign=top style='text-align:left'><B> " + "No. of Structurally Invalid PAN (PANINVALID)" + "</B></CENTER></TD>");
					toReturn.append("</TR>");
					// Deductee Records are provided only in Regular File and C3

					toReturn.append("<TR>");
					toReturn.append("<TD  ALIGN=RIGHT width=195>" + fStatistics.getNo_of_Valid_Pan() + " </TD>");

					if (!fStatistics.getNo_of_PAN_Applied().equals("-"))
					{
						toReturn.append("<TD  ALIGN=RIGHT width=189>" + fStatistics.getNo_of_PAN_Applied() + " </TD>");
					}
					else
					{
						toReturn.append("<TD  ALIGN=RIGHT width=189>" + "-" + " </TD>");
					}

					if (!fStatistics.getNo_of_PAN_NotAvailabble().equals("-"))
					{
						toReturn.append("<TD  ALIGN=RIGHT width=189>" + fStatistics.getNo_of_PAN_NotAvailabble() + " </TD>");
					}
					else
					{
						toReturn.append("<TD  ALIGN=RIGHT width=189>" + "-" + " </TD>");
					}
					if (!fStatistics.getNo_of_PAN_Invalid().equals("-"))
					{
						toReturn.append("<TD  ALIGN=RIGHT width=189>" + fStatistics.getNo_of_PAN_Invalid() + " </TD>");
					}
					else
					{
						toReturn.append("<TD  ALIGN=RIGHT width=189>" + "-" + " </TD>");
					}

					toReturn.append("</TR>");
										
					toReturn.append("</TABLE><P>");
				
					}
					
				}	
				
				if (bsrPresent)
				{
				    
					toReturn.append(
				    "<TABLE BORDER=1 CELLSPACING=0 CELLPADDING=0 BORDERCOLOR=000000 style='border-collapse:collapse; border:none;mso-border-alt:solid windowtext .5pt;mso-padding-alt:0in 5.4pt 0in 5.4pt'>");
				    toReturn.append("<TR>");
				    toReturn.append("<TD ALIGN=LEFT width=581 ><B> " + "Distinct Count of mismatch of Bank branch code in  e-TDS/TCS statement with the authorized bank branch code master " + "</B></CENTER></TD>");
				    toReturn.append("<TD ALIGN=Right width=181 > " +  bsrCount + "</CENTER></TD>");
				    toReturn.append("</TR>");
				    toReturn.append("</TABLE><P>");
				
				    toReturn.append(
				    "<TABLE BORDER=1 CELLSPACING=0 CELLPADDING=0 BORDERCOLOR=000000 style='border-collapse:collapse; border:none;mso-border-alt:solid windowtext .5pt;mso-padding-alt:0in 5.4pt 0in 5.4pt'>");
				    toReturn.append("<TR>");
				    toReturn.append("<TD ALIGN=LEFT width=762 ><B> " + "Details of bank branch code not present in list of authorized bank branch code master" + "</B></CENTER></TD>");
				    toReturn.append("</TR>");
				    toReturn.append("<TR>");
				    toReturn.append("<TD ALIGN=LEFT width=762 ><B> " + bsr + "</B></CENTER></TD>");
				    toReturn.append("</TR>");
				    toReturn.append("</TABLE>");
				    
				}
				if (fStatistics.getUpload_Type().equals(UPLOADTYPE_REGULAR)
					|| fStatistics.getTransaction_Type().equals(TRANSACTIONTYPE_ADDITION_CHALLAN)
					|| fStatistics.getTransaction_Type().equals(TRANSACTIONTYPE_CORRECTION_DEDUCTEE))
				{
					toReturn.append("<BR><B> Last Deductee (LD) Detail Record Number in Challan : </B>");
					if (!fStatistics.getNo_of_LD().equals(""))
					{
						StringTokenizer str = new StringTokenizer(fStatistics.getNo_of_LD(), "&");
						int no_of_token = str.countTokens();
						for (int i = 0; i < no_of_token; i++)
						{
							if (i < (no_of_token - 1))
								toReturn.append(str.nextToken() + ", ");
							else
								toReturn.append(str.nextToken());
						}
						toReturn.append(" (eg. LD1=2 means \"Last Deductee detail record no. of Challan 1 is 2\")");
					}
					else
					{
						toReturn.append(" - ");
					}
				}
				// Salaray Detail Record are Present in 24Q only
				if (fStatistics.getForm_No().equals(FORM_24Q)
					&& fStatistics.getUpload_Type().equals(UPLOADTYPE_REGULAR)
					|| fStatistics.getTransaction_Type().equals(TRANSACTIONTYPE_CORRECTION_SALARY)
					|| fStatistics.getTransaction_Type().equals(TRANSACTIONTYPE_REPLACE_SALARY))
				{
					toReturn.append("<BR>");
					if (!fStatistics.getNo_of_LS().equals(""))
					{
						toReturn.append("<B> Last Salary (LS) Details Record Number in Batch : </B>" + fStatistics.getNo_of_LS() + " </B><BR>");
					}
					else
					{
						toReturn.append("<B> Last Salary (LS) Details Record Number in Batch </B>: - <BR>");
					}

				} // In Regular, C3 and C9 these field will be shown in Statistic Report
			} // In C1 and Batch Cancellation these field will not be shown in Statistic Report
			if (isTANChanged)
			{
				toReturn.append("* TAN correction is subjected to approval from Income Tax Department");
			}
			toReturn.append("<BR> FVU Version : " + FVUVersion + " &nbsp;&nbsp; Input File Name : " + fileName);
			toReturn.append("<BR><BR>");
			toReturn.append("</TD>" + "</TR> " + "</TABLE><BR><BR><BR>");
			if (lastBatchOfFile)
			{
				toReturn.append("<span ><br clear=all style='page-break-before:always'></span>");
			}
			toReturn.append("</BODY>");
			toReturn.append("</HTML>");

			flgObj.writeStatisticFile(statisticFileName, toReturn, fStatistics, fileOpenFlag, false);
			toReturn = new StringBuffer();
			// FORMAT OF RECEIPT - END
			System.out.println("FileGenerator.java createStatisticFileString() method is returning");
			return;
		}
		catch (Exception e)
		{
			e.printStackTrace();
			System.err.println("Exception in FileGenerator.java createStatisticFileString() method : "); e.printStackTrace();
			return;
		}
	}

	//	public void generateStatisticFile(String panDataString, String statisticDataString, String statFileName)
	public void generateStatisticFile(FormValidator obj_FrmValidator, String statFileName, String fileName, String FVUVersion)
	{
		try
		{
			//     obj_FileGenerator.generateStatisticFile( obj_FormValidator.getReceiptString().toString() , obj_FormValidator.getStatisticFileStrBuff().toString() , statisticFileName );
			System.out.println("Inside generateStatisticFile Method ");

			ArrayList panDataList = parseString(obj_FrmValidator.getReceiptString().toString(), "~");
			Object panDataArray[] = panDataList.toArray();
			obj_FrmValidator.setReceiptString(new StringBuffer());
			ArrayList statisticDataList = parseString(obj_FrmValidator.getStatisticFileStrBuff().toString(), "\n");
			Object statisticDataArray[] = statisticDataList.toArray();
			obj_FrmValidator.setStatisticFileStrBuff(new StringBuffer());
            
//			 Added for change in statistics File Data ----- Nahush (21 Oct 08)

			ArrayList statisticSalDataList = parseString( obj_FrmValidator.getStatisticSalStrBuff().toString(), "\n");
			Object statisticSalDataArray[] = statisticSalDataList.toArray();
			obj_FrmValidator.setStatisticSalStrBuff(new StringBuffer());

			ArrayList fileHeaderList = parseString((String) statisticDataArray[0], "^");
			Object fileHeaderArray[] = fileHeaderList.toArray();
			ArrayList bsrListToPrint = obj_FrmValidator.getBSRDetails();
				
					
			boolean fileOpenFlag = false;
			boolean lastBatchOfFile = true;
			for (int i = 0; i < panDataArray.length; i++)
			{
				FileStatistics fStatistics = getProvisionalDetail((String) panDataArray[i], "^");
				fStatistics.setForm_Type((String) fileHeaderArray[0]);
				fStatistics.setUpload_Type((String) fileHeaderArray[1]);
				fStatistics = getStatisticFileDetail((String) statisticDataArray[i + 1], "^", fStatistics);
				fStatistics = getStatisticSalDetail((String) statisticSalDataArray[i], "^", fStatistics);
				String distinctBSR ="  ";
				int distinctBSRCount =0;
				boolean invalidBSRPresent=true;
				ArrayList finalList = new ArrayList();
				int countForDistinctBsr =0;

				if ((panDataArray.length - i) == 1)
				{
					lastBatchOfFile = false;
				}
				for (int n=0;n< bsrListToPrint.size();n++)
				{
					String e =bsrListToPrint.get(n).toString();
					StringTokenizer str =new StringTokenizer(e,"^");
					String bsrCode = str.nextToken();
					String batchNo = str.nextToken();
					countForDistinctBsr =0;			  
					if (Integer.parseInt(batchNo) == i+1)
					{
						if (finalList.size() == 0)
							finalList.add(bsrCode);
						for(int k=0;k < finalList.size();k++)
						{
							if(bsrCode.equals(finalList.get(k).toString()))
								countForDistinctBsr=countForDistinctBsr+1;
							
						}
						if (countForDistinctBsr == 0)
						finalList.add(bsrCode);
					
					}
				
					
				}
				
				if (finalList.size() == 0)
				invalidBSRPresent= false;
				else
				{
				
					distinctBSRCount =finalList.size();
					distinctBSR ="";
				
					for (int k=0;k< finalList.size();k++)
				
					{
					
						distinctBSR = distinctBSR + finalList.get(k).toString() + ", ";
				
					}
					
				}	
						
				distinctBSR = distinctBSR.substring(0,distinctBSR.length()-2);
				createStatisticFile(fStatistics, statFileName, fileOpenFlag, lastBatchOfFile, fileName, FVUVersion,invalidBSRPresent,distinctBSR,distinctBSRCount);
				fileOpenFlag = true;
			}
			//	return htmlStatisticFileStringBuffer;
		}
		catch (Exception e)
		{
			System.err.println("generateStatisticFile Method : ");e.printStackTrace();
			e.printStackTrace();
			StringBuffer htmlBuffer = new StringBuffer();
			
			//	return htmlBuffer;
		}
	}
	/*
	 * Method to parse the HTML Error file Data from the Error String Buffer
	 */
	private FileStatistics parseDelemitedErrorFile(String StringToParse, String Seperator)
	{
		//	System.out.println("Inside parseDelemitedErrorFile Method ");
		FileStatistics fStatistics = new FileStatistics();
		int counter = 1;
		boolean NullField = false;
		boolean FieldFound = false;
		boolean Caret = true;
		int localCaretCounter = 0;
		StringTokenizer Obj_st = new StringTokenizer(StringToParse, Seperator, true);
		while (Obj_st.hasMoreTokens())
		{
			String token = Obj_st.nextToken();
			NullField = false;
			FieldFound = false;
			if ((token.equals(FIELD_SEPERATOR) && Caret) || token.trim().length() == 0)
			{
				NullField = true;
				FieldFound = true;
			}
			if (token.equals(FIELD_SEPERATOR))
			{
				Caret = true;
				token = "-";
				if ((counter == 1) && (localCaretCounter == 0))
				{
					counter++;
					fStatistics.setLine_No(token);
				}
				localCaretCounter++;
			}
			else
			{
				Caret = false;
				FieldFound = true;
			}
			if (counter > 7)
			{
				break;
			}
			if (FieldFound)
			{
				if (counter == 1) // Line No
				{
					fStatistics.setLine_No(token);
				}	
				else if (counter == 2) //Upload Type.
				{
					fStatistics.setBatch_No("Null");
					fStatistics.set_Upload_Type(token);
				
				}
				else if (counter == 3) //Field Name
				{
					fStatistics.set_Field_Name(token);
				
				} 
				else if (counter == 4) //Challan No
				{
					fStatistics.setChallan_No(token);
				
				  
				}
				else if (counter == 5) //Deductee No
				{
					fStatistics.setDeductee_No(token);
				 	
				}
				else if (counter == 6) //Error Code
				{
					fStatistics.setError_Code(token);
					    
				}
				else if (counter == 7) // Error Description
				{
					fStatistics.setError_Description(token);
				
				}
				counter++;
			}
		} //WHILE
		//	System.out.println("Exiting parseDelemitedErrorFile Method ");
		return fStatistics;
	}
	/*
	 * Method to Create HTML Error File
	 */

//	---------------Added by Nahush 
	
	private FileStatistics parseDelemitedWarFile(String StringToParse, String Seperator)
	{
		
		FileStatistics fStatistics = new FileStatistics();
		int counter = 1;
		boolean NullField = false;
		boolean FieldFound = false;
		boolean Caret = true;
		int localCaretCounter = 0;
		StringTokenizer Obj_st = new StringTokenizer(StringToParse, Seperator, true);
		while (Obj_st.hasMoreTokens())
		{
			String token = Obj_st.nextToken();
			NullField = false;
			FieldFound = false;
			if ((token.equals(FIELD_SEPERATOR) && Caret) || token.trim().length() == 0)
			{
				NullField = true;
				FieldFound = true;
			}
			if (token.equals(FIELD_SEPERATOR))
			{
				Caret = true;
				token = "-";
				if ((counter == 1) && (localCaretCounter == 0))
				{
					counter++;
					fStatistics.setLine_No(token);
				}
				localCaretCounter++;
			}
			else
			{
				Caret = false;
				FieldFound = true;
			}
			if (counter > 6)
			{
				break;
			}
			if (FieldFound)
			{
				if (counter == 1) // Line No
				{
					fStatistics.setLine_No(token);
				}
				else if (counter == 2) //Batch No.
				{
					fStatistics.setBatch_No(token);
				}
				else if (counter == 3) //Challan No
				{
					fStatistics.setChallan_No(token);
				}
				else if (counter == 4) //Deductee No
				{
					fStatistics.setDeductee_No(token);
				}
				else if (counter == 5) //Error Code
				{
					fStatistics.setError_Code(token);
				}
				else if (counter == 6) // Error Description
				{
					fStatistics.setError_Description(token);
				}
				counter++;
			}
		} //WHILE
		
		return fStatistics;
	}	
	
	

	
	private FileStatistics parseDelemitedElecWarFile(String StringToParse, String Seperator)
	{
		
		FileStatistics fStatistics = new FileStatistics();
		int counter = 1;
		boolean NullField = false;
		boolean FieldFound = false;
		boolean Caret = true;
		int localCaretCounter = 0;
		StringTokenizer Obj_st = new StringTokenizer(StringToParse, Seperator, true);
		while (Obj_st.hasMoreTokens())
		{
			String token = Obj_st.nextToken();
			NullField = false;
			FieldFound = false;
			if ((token.equals(FIELD_SEPERATOR) && Caret) || token.trim().length() == 0)
			{
				NullField = true;
				FieldFound = true;
			}
			if (token.equals(FIELD_SEPERATOR))
			{
				Caret = true;
				token = "-";
				if ((counter == 1) && (localCaretCounter == 0))
				{
					counter++;
					fStatistics.setLine_No(token);
				}
				localCaretCounter++;
			}
			else
			{
				Caret = false;
				FieldFound = true;
			}
			if (counter > 10)
			{
				break;
			}
			if (FieldFound)
			{
				if (counter == 1) // Line No
				{
					fStatistics.setLine_No(token);
				}
				else if (counter == 2) //Batch No.
				{
					fStatistics.setRecord_Type(token);
				}
				else if (counter == 3) //Batch No.
				{
					fStatistics.setBatch_No(token);
				}
				else if (counter == 4) //Challan No
				{
					fStatistics.setChallan_No(token);
				}
				else if (counter == 5) //Deductee No
				{
					fStatistics.setDeductee_No(token);
				}
				else if (counter == 6) //Challan Tender Date
				{
					fStatistics.setChallan_Tender_date(token);
				}
				else if (counter == 7) // Challan Serial No.
				{
					fStatistics.setChallan_Serial_No(token);
				}
				else if (counter == 8) //BSR Code
				{
					fStatistics.setBSR_Code(token);
				}
				else if (counter == 9) //Error Code
				{
					fStatistics.setError_Code(token);
				}
				else if (counter == 10) // Error Description
				{
					fStatistics.setError_Description(token);
				}
				counter++;
			}
		} //WHILE
		
		return fStatistics;
	}
	
	
	
	//Changed by Nahush
	private StringBuffer createErrorFile(FileStatistics fStatistics, StringBuffer toReturn, boolean paperRetWarFile, boolean electronicRetWarFile)
	{
		
	try
		{ 
			if (paperRetWarFile)
			{
				
				toReturn.append("<TR>");
				toReturn.append("<TD  ALIGN=RIGHT width=70> " + fStatistics.getLine_No() + "</TD>");
				// calling the Method to get the Record Type
				toReturn.append(setRecordType(fStatistics));
				toReturn.append("<TD  ALIGN=RIGHT width=85> " + fStatistics.getBatch_No() + " </TD>");
				toReturn.append("<TD  ALIGN=RIGHT width=85> " + fStatistics.getChallan_No() + " </TD>");
				toReturn.append("<TD  ALIGN=RIGHT width=85> " + fStatistics.getDeductee_No() + " </TD>");
				toReturn.append("<TD  ALIGN=LEFT width=90> " + fStatistics.getError_Code() + " </TD>");
				toReturn.append("<TD  ALIGN=LEFT width=585> " + fStatistics.getError_Description() + " </TD>");
				toReturn.append("</TR>");
				// FORMAT OF RECEIPT - END
				//   System.out.println("FileGenerator.java createErrorFileString() method is returning");
				
			}
			
			else if (electronicRetWarFile)
			{
										
				toReturn.append("<TR>");
				toReturn.append("<TD  ALIGN=RIGHT width=70> " + fStatistics.getLine_No() + "</TD>");
				// calling the Method to get the Record Type
				toReturn.append("<TD  ALIGN=LEFT width=85> " + fStatistics.getRecord_Type() + " </TD>");
				toReturn.append("<TD  ALIGN=RIGHT width=85> " + fStatistics.getBatch_No() + " </TD>");
				toReturn.append("<TD  ALIGN=RIGHT width=85> " + fStatistics.getChallan_No() + " </TD>");
				toReturn.append("<TD  ALIGN=RIGHT width=85> " + fStatistics.getDeductee_No() + " </TD>");
				toReturn.append("<TD  ALIGN=LEFT width=85> " + fStatistics.getChallan_Tender_date() + " </TD>");
				toReturn.append("<TD  ALIGN=RIGHT width=85> " + fStatistics.getChallan_Serial_No() + " </TD>");
				toReturn.append("<TD  ALIGN=RIGHT width=85> " + fStatistics.getBSR_Code() + " </TD>");
				toReturn.append("<TD  ALIGN=LEFT width=90> " + fStatistics.getError_Code() + " </TD>");
				toReturn.append("<TD  ALIGN=LEFT width=585> " + fStatistics.getError_Description() + " </TD>");
				toReturn.append("</TR>");

			}
			else
			{
				
				   toReturn.append("<TR>");
				   toReturn.append("<TD  ALIGN=RIGHT width=70> " + fStatistics.getLine_No() + "</TD>");
				   
				  
				   
				   // calling the Method to get the Record Type
				   toReturn.append(setRecordType(fStatistics));
				   
				  
				   
				   // calling the Method to get the current upload Type
//				   toReturn.append(setUploadType());
				   //toReturn.append("<TD  ALIGN=LEFT width=85> </TD>");
				   toReturn.append("<TD  ALIGN=LEFT width=200> " + fStatistics.get_Upload_Type() + " </TD>");
				   
				   
				   toReturn.append("<TD  ALIGN=LEFT width=200> " + fStatistics.get_Field_Name() + " </TD>");
				   
				  
				   
				   toReturn.append("<TD  ALIGN=LEFT width=85> " + fStatistics.getChallan_No() + " </TD>");
				   
				  
				   toReturn.append("<TD  ALIGN=LEFT width=85> " + fStatistics.getDeductee_No() + " </TD>");
				   
				  
				   
				   toReturn.append("<TD  ALIGN=LEFT width=675 style='white-space:pre-wrap'> " + fStatistics.getError_Code() + " " + fStatistics.getError_Description() + "</TD>");
				   
				   
				   //toReturn.append("<TD  ALIGN=LEFT width=585> " + fStatistics.getError_Description() + " </TD>");
				   toReturn.append("</TR>");
				   // FORMAT OF RECEIPT - END
				   //   System.out.println("FileGenerator.java createErrorFileString() method is returning");
				
			}
			
				// System.out.println("FileGenerator.java createErrorFileString() method is called");
			
		   
//		System.out.println("Line no = " +fStatistics.getLine_No()+ "Upload Type" +fStatistics.get_Upload_Type()+ "Field Name = " +fStatistics.get_Field_Name()+ "Challan no" +fStatistics.getChallan_No()+ "Deductee no = " +fStatistics.getDeductee_No()+ "Error Code = " +fStatistics.getError_Code()+ "Errror Discription = " +fStatistics.getError_Description());
		
            return toReturn; 
		}	
		catch (Exception e)
		{
			System.err.println("Exception in FileGenerator.java createErrorFileString() method : "); e.printStackTrace();
			e.printStackTrace();
			return null;
		}
	}
            
		

	
	
	/*
	 * Method to create the HTML Header of HTML Error File
	 */
	private StringBuffer createHtmlErrorFileHeader(StringBuffer toReturn, boolean paperRetWarFile, boolean electronicRetWarFile)
	{
		// FORMAT OF HTML Error File - Header
		toReturn.append("<HTML>");

		//----------Changed by Nahush
		if (paperRetWarFile)
		{
			toReturn.append("<HEAD> <TITLE> TDS/TCS PAPER STATEMENT WARNING FILE </TITLE></HEAD>");
			toReturn.append("<BODY>");
			toReturn.append("<H3><CENTER> TDS/TCS - PAPER STATEMENT WARNING FILE </CENTER></H3>");

			toReturn.append(
				"<BR>This file is generated by FVU if values in relaxed fields are other then actual value. TIN-FC should verify fields mentioned below with value in paper statement."
					+ " In case any mismatch is observed than data entry error should be rectified and file should be created and validated again using FVU."
					+ " If values are as per paper statement then sent the upload file to upload centre.");
			toReturn.append("<BR><BR>");
			toReturn.append(
			"<TABLE BORDER=1 CELLSPACING=0 CELLPADDING=0 BORDERCOLOR=000000 style='border-collapse:collapse; border:none;mso-border-alt:solid windowtext .5pt;mso-padding-alt:0in 5.4pt 0in 5.4pt'>");
		// First Table
		    toReturn.append("<TR>");
		    toReturn.append("<TD width=70 valign=top style='text-align:left' ><B> " + "  Line no. " + "</B></CENTER></TD>");
		    toReturn.append("<TD width=85 valign=top><B> " + "  Record Type " + "</B></CENTER></TD>");
		    toReturn.append("<TD width=85 valign=top><B> " + "  Batch no. " + "</B></CENTER></TD>");
		    toReturn.append("<TD width=85 valign=top><B> " + "  Challan Details Record no. " + "</B></CENTER></TD>");
		    toReturn.append("<TD width=85 valign=top><B> " + "  Deductee/ Salary Detail no. " + "</B></CENTER></TD>");
		    toReturn.append("<TD width=90 valign=top><B> " + "  Error Code " + "</B></CENTER></TD>");
		    toReturn.append("<TD width=585 valign=top><B> " + "  Error Description " + "</B></CENTER></TD>");
		    toReturn.append("</TR>");

		}

		else if (electronicRetWarFile)
		{
			toReturn.append("<HEAD> <TITLE> e-TDS/TCS statement warning file </TITLE></HEAD>");
			toReturn.append("<BODY>");
			toReturn.append("<H3><CENTER><u> e-TDS/TCS statement warning file </u></CENTER></H3>");
			toReturn.append("<BR>e-TDS/TCS statement warning file is generated by FVU if :");
			toReturn.append("<BR>&nbsp &nbsp &nbsp &nbsp 1.	The value in the Bank Branch Code (BSR code) field of challan in the e-TDS/TCS statements is not present in the authorized list of collecting Bank Branch" 
					         +"&nbsp &nbsp &nbsp &nbsp &nbsp &nbsp &nbsp Codes in the FVU and/or");
			toReturn.append("<BR>&nbsp &nbsp &nbsp &nbsp 2.	If the PAN of the deductor is same as that of any deductee in the e-TDS/TCS statement.");
			//added by sourabh
			toReturn.append("<BR>&nbsp &nbsp &nbsp &nbsp 3.	If the challans details of the statement do not match with the details uploaded by the bank.");
			//added by Abhishek on 28 dec 11
			toReturn.append("<BR>&nbsp &nbsp &nbsp &nbsp 4.	In case tax is deducted at higher rate and corresponding rate of deduction is less than 20%.");
			toReturn.append("<BR>&nbsp &nbsp &nbsp &nbsp 5.	If date of deduction is beyond the quarter.");  //Added by Abhishek on 07032012
			toReturn.append("<BR>&nbsp &nbsp &nbsp &nbsp 6.	If TAN name of the deductor is not present in TAN master of Income Tax Department (ITD).");  // New Error added in warning file in fvu 5.0
			toReturn.append(
				"<BR>This file is generated to give an alert to the deductor about the records in which invalid values are mentioned.");
					
			toReturn.append("<BR><BR>");
			toReturn.append(
			"<TABLE BORDER=1 CELLSPACING=0 CELLPADDING=0 BORDERCOLOR=000000 style='border-collapse:collapse; border:none;mso-border-alt:solid windowtext .5pt;mso-padding-alt:0in 5.4pt 0in 5.4pt'>");
		// First Table
		    toReturn.append("<TR>");
		    toReturn.append("<TD width=70 valign=top style='text-align:left' ><B> " + "  Line no. in the text file " + "</B></CENTER></TD>");
		    toReturn.append("<TD width=85 valign=top><B> " + "  Record Type " + "</B></CENTER></TD>");
		    toReturn.append("<TD width=85 valign=top><B> " + "  Batch no. in the text file" + "</B></CENTER></TD>");
		    toReturn.append("<TD width=85 valign=top><B> " + "  Challan detail record no. " + "</B></CENTER></TD>");
		    toReturn.append("<TD width=85 valign=top><B> " + "  Deductee/ Salary detail record no. " + "</B></CENTER></TD>");
		    toReturn.append("<TD width=90 valign=top><B> " + "  Challan tender date " + "</B></CENTER></TD>");
		    toReturn.append("<TD width=90 valign=top><B> " + "  Challan Serial no. " + "</B></CENTER></TD>");
		    toReturn.append("<TD width=90 valign=top><B> " + "  BSR code " + "</B></CENTER></TD>");
		    toReturn.append("<TD width=95 valign=top><B> " + "  Error Code " + "</B></CENTER></TD>");
		    toReturn.append("<TD width=585 valign=top><B> " + "  Error Description " + "</B></CENTER></TD>");
		    toReturn.append("</TR>");
		    
		}
		else
		{
			toReturn.append("<HEAD> <TITLE> TDS/TCS ERROR FILE </TITLE></HEAD>");
			toReturn.append("<BODY>");
			toReturn.append("<H3><CENTER> TDS/TCS - ERROR FILE </CENTER></H3>");

			toReturn.append(
                            "<TABLE BORDER=1 CELLSPACING=0 CELLPADDING=0 BORDERCOLOR=000000 style='border-collapse:collapse; border:none;mso-border-alt:solid windowtext .5pt;mso-padding-alt:0in 5.4pt 0in 5.4pt'>");
			toReturn.append("<TR>");
			toReturn.append("<TD width=70 valign=top style='text-align:right' ><B> " + "  Line No " + "</B></CENTER></TD>");
		    toReturn.append("<TD width=85 valign=top><B> " + "  Record Type " + "</B></CENTER></TD>");
		    toReturn.append("<TD width=200 valign=top><B> " + "  Statement Type " + "</B></CENTER></TD>");
		    toReturn.append("<TD width=200 valign=top><B> " + "  Field Name" + "</B></CENTER></TD>");
		    toReturn.append("<TD width=85 valign=top><B> " + "  Challan Details Record Number " + "</B></CENTER></TD>");
		    toReturn.append("<TD width=85 valign=top><B> " + "  Deductee/ Salary Detail No. " + "</B></CENTER></TD>");
		    toReturn.append("<TD width=675 valign=top><B> " + "  Error Code & Description " + "</B></CENTER></TD>");
		    //toReturn.append("<TD width=585 valign=top><B> " + "  Error Description " + "</B></CENTER></TD>");
		    toReturn.append("</TR>");
         
		}

//		-------------------------
		return toReturn;
	
	}

	/*
	 * Method to create the HTML Footer of HTML Error File
	 */
	private StringBuffer createHtmlErrorFileFooter(StringBuffer toReturn)
	{
		//		FORMAT OF HTML Error File - Footer
		toReturn.append("</TABLE><BR>");
		toReturn.append("<BR><BR><BR>");
		toReturn.append("</BODY>");
		toReturn.append("</HTML>");
		return toReturn;
	}

	/*
		* Method to create the HTML Footer of HTML Error File
		*/
	private StringBuffer createHtmlErrorFileFooter(StringBuffer toReturn, String inputFileName,boolean eWarnFl)
	{
		//		FORMAT OF HTML Error File - Fooetr
        if (eWarnFl)
        {
        	toReturn.append("</TABLE><BR>");
        	toReturn.append("<BR> <B>Bank branch code not present in the list of authorized bank branches:</B>");
        	toReturn.append("<BR> <P>The Bank Branch Code is provided on the challan counterfoil along with the tender date and challan serial no. by the collecting bank branch where TDS / TCS has been deposited.");
        	toReturn.append("<BR> Deductor / Collector should verify the Bank Branch Code mentioned in the e-TDS/TCS statement with the bank branch code on the challan counterfoil provided by the bank.");
        	toReturn.append("<BR> In case of mismatch, the bank branch codes as per the challan counterfoil should be mentioned in the e-TDS/TCS statement and the file should be revalidated through FVU.");
        	toReturn.append("<BR> In case there is no mismatch then the .fvu file created by the FVU should be submitted to the TIN-FC. </P>");
        	toReturn.append("<BR> <P><B>Same PAN in deductor and deductee PAN field.</P></B>");
        	toReturn.append("<P>PAN of the deductor given in the deductor details should normally not appear in the deductee details.");
        	toReturn.append("<BR>Deductor/Collector should verify the PAN in the deductee details and if the same has been correctly entered, then the .fvu file created by the FVU should be submitted to the TIN-FC.</P>");
        	
        }
        else

        	toReturn.append("</TABLE><BR>");
        
		toReturn.append("<BR> FVU Version : " + TDSFVUVersion + " &nbsp;&nbsp; Input File Name : " + inputFileName);
       
       
        //-------changed for validating the % of structurally valid PAN ---By Manvendra
        //----------------------------------------------------------------------------
       // if(StructurallyinvalidPAN)
       // {
           //toReturn.append("<BR> In calculation of number of structurally valid PAN deleted and updated deductee are not considered");        
       // }
       //----------------------------------------------------------------------------
       
        toReturn.append("<BR><BR><BR>");
		toReturn.append("</BODY>");
		toReturn.append("</HTML>");
		return toReturn;
	}



	public StringBuffer generateHtmlErrorFile(String errorDataString)
	{
		System.out.println("Entering into this mtd");
		
		try
		{
			ArrayList errorDataList = parseString(errorDataString, "\n");
			Object errorDataArray[] = errorDataList.toArray();
			StringBuffer htmlErrorFileStringBuffer = new StringBuffer();
			boolean paperRetWarFile = false;
			boolean electronicRetWarFile = false;
			htmlErrorFileStringBuffer = createHtmlErrorFileHeader(htmlErrorFileStringBuffer, paperRetWarFile, electronicRetWarFile);
			for (int i = 0; i < errorDataArray.length; i++)
			{
				System.out.println(" in loooop "+i);
				FileStatistics fStatistics = parseDelemitedErrorFile((String) errorDataArray[i], "^");
				htmlErrorFileStringBuffer = createErrorFile(fStatistics, htmlErrorFileStringBuffer, paperRetWarFile, electronicRetWarFile);
			}
			htmlErrorFileStringBuffer = createHtmlErrorFileFooter(htmlErrorFileStringBuffer);
			return htmlErrorFileStringBuffer;
		}
		catch (Exception e)
		{
			System.err.println(" Exception in FileGenerator.java generateHtmlErrorFile Method : " ); e.printStackTrace();
			StringBuffer htmlBuffer = new StringBuffer();
			return htmlBuffer;
		}
	}

	public StringBuffer generateHtmlErrorFile(String errorDataString, boolean appedHtmlErrorFileHeader, boolean appedHtmlErrorFileFooter, boolean paperRetWarFile, String inputFileName,boolean electronicRetWarFile )
	{
		try
		{
			ArrayList errorDataList = parseString(errorDataString, "\n");

			Object errorDataArray[] = errorDataList.toArray();

			StringBuffer htmlErrorFileStringBuffer = new StringBuffer();

			if (appedHtmlErrorFileHeader)
			{
				htmlErrorFileStringBuffer = createHtmlErrorFileHeader(htmlErrorFileStringBuffer, paperRetWarFile, electronicRetWarFile);
			}

			for (int i = 0; i < errorDataArray.length; i++)
			{
				if(paperRetWarFile)
				
				{	
				   FileStatistics fStatistics = parseDelemitedWarFile((String) errorDataArray[i], "^");
				
				   htmlErrorFileStringBuffer = createErrorFile(fStatistics, htmlErrorFileStringBuffer, paperRetWarFile, electronicRetWarFile);
			
				}
			
				else if (electronicRetWarFile)
				
				{
					FileStatistics fStatistics = parseDelemitedElecWarFile((String) errorDataArray[i], "^");
					
					htmlErrorFileStringBuffer = createErrorFile(fStatistics, htmlErrorFileStringBuffer, paperRetWarFile, electronicRetWarFile);

				}
			 
				else
					
				{
					FileStatistics fStatistics = parseDelemitedErrorFile((String) errorDataArray[i], "^");
					
					htmlErrorFileStringBuffer = createErrorFile(fStatistics, htmlErrorFileStringBuffer, paperRetWarFile, electronicRetWarFile);
					
				}

			}
			if (appedHtmlErrorFileFooter)
			{
				htmlErrorFileStringBuffer = createHtmlErrorFileFooter(htmlErrorFileStringBuffer, inputFileName,electronicRetWarFile);
			}
			return htmlErrorFileStringBuffer;
		}
		catch (Exception e)
		{
			System.err.println(" Exception in FileGenerator.java generateHtmlErrorFile Method : ");e.printStackTrace();
			StringBuffer htmlBuffer = new StringBuffer();
			return htmlBuffer;
		}
	}

//	---------------Changed by Nahush for change in error file format and validating Deductor PAN against PAN of deductee.
	
	private StringBuffer setRecordType(FileStatistics fStatistics)
	{
		
		StringBuffer toReturn = new StringBuffer();
		if (fStatistics.getLine_No().equals("-") && fStatistics.getError_Code().equals("-"))
		{
			
			toReturn.append("<TD  ALIGN=LEFT width=90> " + "Metering" + " </TD>");
		}
		else if (fStatistics.getDeductee_No().equals("NA") && fStatistics.getChallan_No().equals("NA"))
		{
//          variable added to validate the % of structurally valid PAN  :: Manvendra Singh 31-Aug-2007
            // ----------------------------------------------------------------
            
            StructurallyinvalidPAN = true ;
			toReturn.append("<TD  ALIGN=LEFT width=90> " + "File Level" + " </TD>");
            // ----------------------------------------------------------------
		}
		else if (!fStatistics.getDeductee_No().equals("-") && (fStatistics.getChallan_No().equals("-") || fStatistics.getChallan_No().equals("NA")))
		{
			
			toReturn.append("<TD  ALIGN=LEFT width=90> " + "Salary Detail" + " </TD>");
		}
		else if (!fStatistics.getDeductee_No().equals("-"))
		{
			toReturn.append("<TD  ALIGN=LEFT width=90> " + "Deductee" + " </TD>");
		}
		else if (!fStatistics.getChallan_No().equals("-"))
		{
			
			toReturn.append("<TD  ALIGN=LEFT width=90> " + "Challan" + " </TD>");
		}
		else if (!fStatistics.getError_Code().substring(0,6).equals("T-FV-1")) 
		{
			toReturn.append("<TD  ALIGN=LEFT width=90> " + "Batch" + " </TD>");
		}
		else if (!fStatistics.getBatch_No().equals("-") && !(fStatistics.get_Upload_Type().equals("NA")) && !(fStatistics.getError_Code().substring(0,6).equals("T-FV-1")))
		{
		    toReturn.append("<TD  ALIGN=LEFT width=90> " + "Batch" + " </TD>");
           
		}
		else
		{
			toReturn.append("<TD  ALIGN=LEFT width=90> " + "File Header" + " </TD>");
		}
		return toReturn;
	}

	
		
	public String createPANStatFileHeader()
	{
		// FORMAT OF PAN Statistic File - Header
		StringBuffer toReturn = new StringBuffer();
		toReturn.append("<HTML>");
		toReturn.append("<HEAD> <TITLE> TDS/TCS PAN STATISTICS FILE </TITLE></HEAD>");
		toReturn.append("<BODY>");
		return toReturn.toString();
	}

	public FileStatistics getPANStatBatchDetail(String StringToParse, String Seperator, FileStatistics fStatistics)
	{
		System.out.println("FileGenerator.java getPANStatBatchDetail() method Called");
		StringTokenizer batch = new StringTokenizer(StringToParse, Seperator);
		int counter = 0;
		while (batch.hasMoreTokens())
		{
			String token = batch.nextToken();
			if (counter == 0) // Batch Number
			{
				fStatistics.setBatch_No(token);
			}
			else if (counter == 1) //Form No.
			{
				fStatistics.setForm_No(token);
			}
			else if (counter == 2) //Transaction Type
			{
				fStatistics.setTransaction_Type(token);
			}
			else if (counter == 3) //TAN
			{
				fStatistics.setTAN(token);
			}
			else if (counter == 4) //Last TAN
			{
				fStatistics.setLastTAN(token);
			}
			else if (counter == 5) //PAN of TAN
			{
				fStatistics.setPAN_of_TAN(token);
			}
			else if (counter == 6) // Assmnt Year
			{
				fStatistics.setAssmnt_Year(token);
			}
			else if (counter == 7) // Financial Year
			{
				fStatistics.setFinancial_Year(token);
			}
			else if (counter == 8) // Quarter
			{
				fStatistics.setPeriodicity(token);
			}
			else if (counter == 9) // Name of TAN(Deductor/Collector/Employer)
			{
				fStatistics.setName_of_Deductor(token);
			}
			else if (counter == 10) // Form Type
			{
				fStatistics.setForm_Type(token);
			}
			counter++;
		} // while () inner While
		System.out.println("FileGenerator.java getStatisticaFileDetail() method is returning ");
		return fStatistics;
	}

	public String createPANStatTableStructureStart(String batchRecDataForPanStat)
	{
		FileStatistics fStatistics = new FileStatistics();
		getPANStatBatchDetail(batchRecDataForPanStat, "^", fStatistics);
		StringBuffer toReturn = new StringBuffer();
		toReturn.append(
			"<TABLE BORDER=1 BORDERCOLOR=\"000000\" CELLSPACING=0 CELLPADDING=0 style='border-collapse:collapse; border:none;mso-border-alt:solid windowtext .5pt;mso-padding-alt:0in 5.4pt 0in 5.4pt'>"
				+ "<TR>"
				+ "<TD><BR>");
		toReturn.append("<H3><CENTER> TDS/TCS - PAN STATISTICS - Batch Number " + fStatistics.getBatch_No() + "</CENTER></H3>");
		toReturn.append("<BR>");
		toReturn.append(
			"<TABLE BORDER=.5pt CELLSPACING=0 CELLPADDING=0 BORDERCOLOR=000000 style='border-collapse:collapse; border:none;mso-border-alt:solid windowtext .5pt;mso-padding-alt:0in 5.4pt 0in 5.4pt'>");
		toReturn.append("<TR>");
		if (fStatistics.getForm_No().equals(FORM_27EQ))
		{
			toReturn.append("<TD width=500 valign=top><B> " + "  Name of Collector	" + "</B></CENTER></TD>");
			if (!fStatistics.getTransaction_Type().equals(TRANSACTIONTYPE_CORRECTION_BATCH)
				|| (fStatistics.getTransaction_Type().equals(TRANSACTIONTYPE_CORRECTION_BATCH) && fStatistics.getTAN().equals(fStatistics.getLastTAN())))
			{
				toReturn.append("<TD width=250 valign=top><B> " + "  TAN of Collector " + "</B></CENTER></TD>");
			}
			else
			{
				toReturn.append("<TD width=166 valign=top><B> " + "  TAN of Collector " + "</B></CENTER></TD>");
				toReturn.append("<TD width=168 valign=top><B> " + "  New TAN of Collector* " + "</B></CENTER></TD>");
			}
		}
		else
		{
			toReturn.append("<TD width=500 valign=top><B> " + "  Name of Deductor " + "</B></CENTER></TD>");
			if (!fStatistics.getTransaction_Type().equals(TRANSACTIONTYPE_CORRECTION_BATCH)
				|| (fStatistics.getTransaction_Type().equals(TRANSACTIONTYPE_CORRECTION_BATCH) && fStatistics.getTAN().equals(fStatistics.getLastTAN())))
			{
				toReturn.append("<TD width=250 valign=top><B> " + "  TAN of Deductor " + "</B></CENTER></TD>");
			}
			else
			{
				toReturn.append("<TD width=166 valign=top><B> " + "  TAN of Deductor " + "</B></CENTER></TD>");
				toReturn.append("<TD width=168 valign=top><B> " + "  New TAN of Deductor* " + "</B></CENTER></TD>");
			}
		}
		toReturn.append("</TR>");
		toReturn.append("<TR>");
		toReturn.append("<TD  ALIGN=LEFT width=500> " + fStatistics.getName_of_Deductor() + "</TD>");
		if (!fStatistics.getTransaction_Type().equals(TRANSACTIONTYPE_CORRECTION_PAN))
		{
			if (!fStatistics.getTransaction_Type().equals(TRANSACTIONTYPE_CORRECTION_BATCH)
				|| (fStatistics.getTransaction_Type().equals(TRANSACTIONTYPE_CORRECTION_BATCH) && fStatistics.getTAN().equals(fStatistics.getLastTAN())))
			{
				toReturn.append("<TD  ALIGN=LEFT width=250> " + fStatistics.getTAN() + " </TD>");
			}
			else
			{
				/* In correction Files-C1 i.e Batch Correction if the TAN Changes than the TAN will be shown under "NEW TAN of Deductor" column of Statistic Report
					* and OLD TAN will be shown under "TAN of Deductor" column. This is Because TAN Change is subjected to Approval from ITD. 
					*/
				toReturn.append("<TD  ALIGN=LEFT width=166> " + fStatistics.getLastTAN() + " </TD>");
				toReturn.append("<TD  ALIGN=LEFT width=168> " + fStatistics.getTAN() + " </TD>");
			}
		}
		else
		{
			toReturn.append("<TD  ALIGN=LEFT width=250> " + fStatistics.getLastTAN() + " </TD>");
		}
		toReturn.append("</TR>");
		toReturn.append("</TABLE><P>");

		// 2 Table
		toReturn.append(
			"<TABLE BORDER=1 CELLSPACING=0 CELLPADDING=0 BORDERCOLOR=000000 style='border-collapse:collapse; border:none;mso-border-alt:solid windowtext .5pt;mso-padding-alt:0in 5.4pt 0in 5.4pt'>");
		toReturn.append("<TR>");
		if (fStatistics.getForm_No().equals(FORM_27EQ))
		{
			toReturn.append("<TD width=250 valign=top><B> " + "  PAN of Collector " + "</B></CENTER></TD>");
		}
		else
		{
			toReturn.append("<TD width=250 valign=top><B> " + "  PAN of Deductor " + "</B></CENTER></TD>");
		}
		toReturn.append("<TD valign=top><B> " + "  Form Number  " + "</B></CENTER></TD>");
		toReturn.append("<TD valign=top><B> " + "  Form Type  " + "</B></CENTER></TD>");
		toReturn.append("</TR>");

		toReturn.append("<TR>");
		toReturn.append("<TD  ALIGN=LEFT width=250> " + fStatistics.getPAN_of_TAN() + " </TD>");
		toReturn.append("<TD  ALIGN=LEFT width=250> " + fStatistics.getForm_No() + " </TD>");
		if (fStatistics.getForm_Type().equals(FILETYPE_SALARY_ELECTRONIC))
		{
			toReturn.append("<TD  ALIGN=LEFT width=250>" + "Salary (Electronic)" + "</TD>");
		}
		else if (fStatistics.getForm_Type().equals(FILETYPE_SALARY_DIGITAL))
		{
			toReturn.append("<TD  ALIGN=LEFT width=250>" + "Salary (Paper)" + "</TD>");
		}
		else if (fStatistics.getForm_Type().equals(FILETYPE_NONSALARY_ELECTRONIC))
		{
			toReturn.append("<TD  ALIGN=LEFT width=250>" + "Non-Salary (Electronic)" + "</TD>");
		}
		else if (fStatistics.getForm_Type().equals(FILETYPE_NONSALARY_DIGITAL))
		{
			toReturn.append("<TD  ALIGN=LEFT width=250>" + "Non-Salary (Paper)" + "</TD>");
		}
		else if (fStatistics.getForm_Type().equals(FILETYPE_TCS_ELECTRONIC))
		{
			toReturn.append("<TD  ALIGN=LEFT width=250>" + "TCS (Electronic)" + "</TD>");
		}
		else if (fStatistics.getForm_Type().equals(FILETYPE_TCS_DIGITAL))
		{
			toReturn.append("<TD  ALIGN=LEFT width=250>" + "TCS (Paper)" + "</TD>");
		}

		toReturn.append("</TR>");
		toReturn.append("</TABLE><P>");

		// 3 Table
		toReturn.append(
			"<TABLE BORDER=1 CELLSPACING=0 CELLPADDING=0 BORDERCOLOR=000000 style='border-collapse:collapse; border:none;mso-border-alt:solid windowtext .5pt;mso-padding-alt:0in 5.4pt 0in 5.4pt'>");
		toReturn.append("<TR>");
		toReturn.append("<TD valign=top><B> " + "  Assessment Year  " + "</B></CENTER></TD>");
		toReturn.append("<TD valign=top><B> " + "  Financial Year  " + "</B></CENTER></TD>");
		toReturn.append("<TD valign=top><B> " + "  Quarter  " + "</B></CENTER></TD>");
		toReturn.append("<TD valign=top><B> " + "  Upload Type  " + "</B></CENTER></TD>");
		toReturn.append("<TD valign=top><B> " + "  Type of Correction " + "</B></CENTER></TD>");
		toReturn.append("</TR>");
		toReturn.append("<TR>");

		String assmntYear = fStatistics.getAssmnt_Year().substring(0, 4);
		String assmntYear2 = fStatistics.getAssmnt_Year().substring(4, 6);
		toReturn.append("<TD  ALIGN=LEFT width=150>" + assmntYear + "-" + assmntYear2 + " </TD>");
//		System.out.println("PAN = " + fStatistics.getFinancial_Year().toString());
		String finanYear = fStatistics.getFinancial_Year().substring(0, 4);
		String finanYear2 = fStatistics.getFinancial_Year().substring(4, 6);
		toReturn.append("<TD  ALIGN=LEFT width=150>" + finanYear + "-" + finanYear2 + "</TD>");
		toReturn.append("<TD  ALIGN=LEFT width=150>" + fStatistics.getPeriodicity() + "</TD>");

		if (fStatistics.getTransaction_Type().equals("-") || fStatistics.getTransaction_Type().equals("R1"))
		{
			toReturn.append("<TD  ALIGN=LEFT width=160>" + "Regular" + "</TD>");
		}
		else
		{
			toReturn.append("<TD  ALIGN=LEFT width=160>" + "Correction" + "</TD>");
		}

		if (fStatistics.getTransaction_Type().equals("-"))
		{
			toReturn.append("<TD  ALIGN=LEFT width=300>" + "NA" + "</TD>");
		}
		else
		{
			//	FOR Transaction Type - START
			if (fStatistics.getTransaction_Type().equals(TRANSACTIONTYPE_CORRECTION_BATCH))
				toReturn.append("<TD  ALIGN=LEFT VALIGN=TOP width=300> " + TRANSACTIONTYPE_CORRECTION_BATCH_LABEL + "</TD>");
			else if (fStatistics.getTransaction_Type().equals(TRANSACTIONTYPE_ADDITION_CHALLAN))
				toReturn.append("<TD  ALIGN=LEFT VALIGN=TOP width=300> " + TRANSACTIONTYPE_ADDITION_CHALLAN_LABEL + "</TD>");
			else if (fStatistics.getTransaction_Type().equals(TRANSACTIONTYPE_CORRECTION_CHALLAN))
				toReturn.append("<TD  ALIGN=LEFT VALIGN=TOP width=300> " + TRANSACTIONTYPE_CORRECTION_CHALLAN_LABEL + "</TD>");
			else if (fStatistics.getTransaction_Type().equals(TRANSACTIONTYPE_CORRECTION_DEDUCTEE))
				toReturn.append("<TD  ALIGN=LEFT VALIGN=TOP width=300> " + TRANSACTIONTYPE_CORRECTION_DEDUCTEE_LABEL + "</TD>");
			else if (fStatistics.getTransaction_Type().equals(TRANSACTIONTYPE_CORRECTION_SALARY))
				toReturn.append("<TD  ALIGN=LEFT VALIGN=TOP width=300> " + TRANSACTIONTYPE_CORRECTION_SALARY_LABEL + "</TD>");
			else if (fStatistics.getTransaction_Type().equals(TRANSACTIONTYPE_CORRECTION_PAN))
				toReturn.append("<TD  ALIGN=LEFT VALIGN=TOP width=300> " + TRANSACTIONTYPE_CORRECTION_PAN_LABEL + "</TD>");
			else if (fStatistics.getTransaction_Type().equals(TRANSACTIONTYPE_CORRECTION_CANCELLATION))
				toReturn.append("<TD  ALIGN=LEFT VALIGN=TOP width=300> " + TRANSACTIONTYPE_CORRECTION_CANCELLATION_LABEL + "</TD>");
			else if (fStatistics.getTransaction_Type().equals(TRANSACTIONTYPE_CANCELLATION_BATCH))
				toReturn.append("<TD  ALIGN=LEFT VALIGN=TOP width=300> " + TRANSACTIONTYPE_CANCELLATION_BATCH_LABEL + "</TD>");
			else if (fStatistics.getTransaction_Type().equals(TRANSACTIONTYPE_REPLACE_SALARY))
				toReturn.append("<TD  ALIGN=LEFT VALIGN=TOP width=300> " + TRANSACTIONTYPE_REPLACE_SALARY_LABEL + "</TD>");
			else if (fStatistics.getTransaction_Type().equals(TRANSACTIONTYPE_CANCELLATION_BATCH_TFC))
				toReturn.append("<TD  ALIGN=LEFT VALIGN=TOP width=300> " + TRANSACTIONTYPE_CANCELLATION_BATCH_LABEL_TFC + "</TD>");

			// FOR Transaction Type - END
		}
		toReturn.append("</TR>");
		toReturn.append("</TABLE><BR>");
		// ******************************************************************
		toReturn.append(
			"<TABLE BORDER=1 CELLSPACING=0 CELLPADDING=0 BORDERCOLOR=000000 style='border-collapse:collapse; border:none;mso-border-alt:solid windowtext .5pt;mso-padding-alt:0in 5.4pt 0in 5.4pt'>");
		toReturn.append("<H4> List of PAN Deficiency</H4>");

		toReturn.append("<TR>");
		toReturn.append("<TD valign=top style='text-align:right'><B> Line Number </B></TD>");
		if (fStatistics.getForm_No().equals(FORM_27EQ))
		{
			toReturn.append("<TD valign=top style='text-align:right'><B> Party Detail Record Number </B></TD>");
		}
		else if (fStatistics.getForm_No().equals(FORM_26Q) || fStatistics.getForm_No().equals(FORM_27Q))
		{
			toReturn.append("<TD valign=top style='text-align:right'><B> Deductee Detail Record Number </B></TD>");
		}
		else
		{
			toReturn.append("<TD valign=top style='text-align:right'><B> Deductee / Salary Detail Record Number </B></TD>");
		}

		toReturn.append("<TD valign=top><B> PAN as mentioned in the statement </B></TD>");
		toReturn.append("<TD valign=top><B> " + "Error  Description" + "</B></TD>");
		toReturn.append("</TR>");

		return toReturn.toString();
	}

	public String createPANStatTableStructureEnd(String fileName)
	{
		StringBuffer toReturn = new StringBuffer();
		//		FORMAT OF HTML Error File - Footer
		toReturn.append("</TABLE><BR>");
		toReturn.append("<BR> FVU Version : " + TDSFVUVersion + " &nbsp;&nbsp; Input File Name : " + fileName);
		toReturn.append("</TABLE></TR></TD><BR>");
		toReturn.append("<span ><br clear=all style='page-break-before:always'></span>");
		toReturn.append("<BR><BR>");
		return toReturn.toString();
	}

	public String createPANStatFileFooter()
	{
		StringBuffer toReturn = new StringBuffer();
		//		FORMAT OF HTML Error File - Footer
		toReturn.append("</TABLE></TD><BR>");
		toReturn.append("<BR><BR><BR>");
		toReturn.append("</BODY>");
		toReturn.append("</HTML>");
		return toReturn.toString();
	}
} //CLASS WRITERFORERROR
